clang 10.0.0git

Macros | Typedefs | Functions | Variables
emmintrin.h File Reference
`#include <xmmintrin.h>`
Include dependency graph for emmintrin.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros
#define | __DEFAULT_FN_ATTRS __attribute__((__always_inline__, __nodebug__, __target__("sse2"), __min_vector_width__(128)))
#define | __DEFAULT_FN_ATTRS_MMX __attribute__((__always_inline__, __nodebug__, __target__("mmx,sse2"), __min_vector_width__(64)))
#define | _mm_load_pd1(dp) _mm_load1_pd(dp)
#define | _mm_slli_si128(a, imm) (__m128i)__builtin_ia32_pslldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))
| Left-shifts the 128-bit integer vector operand by the specified number of bytes. More...
#define | _mm_bslli_si128(a, imm) (__m128i)__builtin_ia32_pslldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))
#define | _mm_srli_si128(a, imm) (__m128i)__builtin_ia32_psrldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))
| Right-shifts the 128-bit integer vector operand by the specified number of bytes. More...
#define | _mm_bsrli_si128(a, imm) (__m128i)__builtin_ia32_psrldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))
#define | _mm_extract_epi16(a, imm)
| Extracts 16 bits from a 128-bit integer vector of [8 x i16], using the immediate-value parameter as a selector. More...
#define | _mm_insert_epi16(a, b, imm)
| Constructs a 128-bit integer vector by first making a copy of the 128-bit integer vector parameter, and then inserting the lower 16 bits of an integer parameter into an offset specified by the immediate-value parameter. More...
#define | _mm_shuffle_epi32(a, imm) (__m128i)__builtin_ia32_pshufd((__v4si)(__m128i)(a), (int)(imm))
| Constructs a 128-bit integer vector by shuffling four 32-bit elements of a 128-bit integer vector parameter, using the immediate-value parameter as a specifier. More...
#define | _mm_shufflelo_epi16(a, imm) (__m128i)__builtin_ia32_pshuflw((__v8hi)(__m128i)(a), (int)(imm))
| Constructs a 128-bit integer vector by shuffling four lower 16-bit elements of a 128-bit integer vector of [8 x i16], using the immediate value parameter as a specifier. More...
#define | _mm_shufflehi_epi16(a, imm) (__m128i)__builtin_ia32_pshufhw((__v8hi)(__m128i)(a), (int)(imm))
| Constructs a 128-bit integer vector by shuffling four upper 16-bit elements of a 128-bit integer vector of [8 x i16], using the immediate value parameter as a specifier. More...
#define | _mm_shuffle_pd(a, b, i)
| Constructs a 128-bit floating-point vector of [2 x double] from two 128-bit vector parameters of [2 x double], using the immediate-value parameter as a specifier. More...
#define | _MM_SHUFFLE2(x, y) (((x) << 1) | (y))
#define | _MM_DENORMALS_ZERO_ON (0x0040)
#define | _MM_DENORMALS_ZERO_OFF (0x0000)
#define | _MM_DENORMALS_ZERO_MASK (0x0040)
#define | _MM_GET_DENORMALS_ZERO_MODE() (_mm_getcsr() & _MM_DENORMALS_ZERO_MASK)
#define | _MM_SET_DENORMALS_ZERO_MODE(x) (_mm_setcsr((_mm_getcsr() & ~_MM_DENORMALS_ZERO_MASK) | (x)))

## Typedefs
typedef double __m128d | __attribute__((__vector_size__(16), __aligned__(16)))

## Functions
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_add_sd (__m128d __a, __m128d __b)
| Adds lower double-precision values in both operands and returns the sum in the lower 64 bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_add_pd (__m128d __a, __m128d __b)
| Adds two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_sub_sd (__m128d __a, __m128d __b)
| Subtracts the lower double-precision value of the second operand from the lower double-precision value of the first operand and returns the difference in the lower 64 bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_sub_pd (__m128d __a, __m128d __b)
| Subtracts two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_mul_sd (__m128d __a, __m128d __b)
| Multiplies lower double-precision values in both operands and returns the product in the lower 64 bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_mul_pd (__m128d __a, __m128d __b)
| Multiplies two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_div_sd (__m128d __a, __m128d __b)
| Divides the lower double-precision value of the first operand by the lower double-precision value of the second operand and returns the quotient in the lower 64 bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_div_pd (__m128d __a, __m128d __b)
| Performs an element-by-element division of two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_sqrt_sd (__m128d __a, __m128d __b)
| Calculates the square root of the lower double-precision value of the second operand and returns it in the lower 64 bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_sqrt_pd (__m128d __a)
| Calculates the square root of the each of two values stored in a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_min_sd (__m128d __a, __m128d __b)
| Compares lower 64-bit double-precision values of both operands, and returns the lesser of the pair of values in the lower 64-bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_min_pd (__m128d __a, __m128d __b)
| Performs element-by-element comparison of the two 128-bit vectors of [2 x double] and returns the vector containing the lesser of each pair of values. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_max_sd (__m128d __a, __m128d __b)
| Compares lower 64-bit double-precision values of both operands, and returns the greater of the pair of values in the lower 64-bits of the result. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_max_pd (__m128d __a, __m128d __b)
| Performs element-by-element comparison of the two 128-bit vectors of [2 x double] and returns the vector containing the greater of each pair of values. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_and_pd (__m128d __a, __m128d __b)
| Performs a bitwise AND of two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_andnot_pd (__m128d __a, __m128d __b)
| Performs a bitwise AND of two 128-bit vectors of [2 x double], using the one's complement of the values contained in the first source operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_or_pd (__m128d __a, __m128d __b)
| Performs a bitwise OR of two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_xor_pd (__m128d __a, __m128d __b)
| Performs a bitwise XOR of two 128-bit vectors of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpeq_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] for equality. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmplt_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are less than those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmple_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are less than or equal to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpgt_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are greater than those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpge_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are greater than or equal to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpord_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are ordered with respect to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpunord_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are unordered with respect to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpneq_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are unequal to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnlt_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not less than those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnle_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not less than or equal to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpngt_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not greater than those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnge_pd (__m128d __a, __m128d __b)
| Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not greater than or equal to those in the second operand. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpeq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmplt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmple_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpgt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpge_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpord_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is "ordered" with respect to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpunord_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is "unordered" with respect to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpneq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnlt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not less than the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnle_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not less than or equal to the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpngt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not greater than the corresponding value in the second parameter. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cmpnge_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not greater than or equal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comieq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comilt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comile_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comigt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comige_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_comineq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomieq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomilt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomile_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomigt_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomige_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_ucomineq_sd (__m128d __a, __m128d __b)
| Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter. More...
static __inline__ __m128 __DEFAULT_FN_ATTRS | _mm_cvtpd_ps (__m128d __a)
| Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two single-precision floating-point values, returned in the lower 64 bits of a 128-bit vector of [4 x float]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cvtps_pd (__m128 __a)
| Converts the lower two single-precision floating-point elements of a 128-bit vector of [4 x float] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cvtepi32_pd (__m128i __a)
| Converts the lower two integer elements of a 128-bit vector of [4 x i32] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cvtpd_epi32 (__m128d __a)
| Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in the lower 64 bits of a 128-bit vector of [4 x i32]. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_cvtsd_si32 (__m128d __a)
| Converts the low-order element of a 128-bit vector of [2 x double] into a 32-bit signed integer value. More...
static __inline__ __m128 __DEFAULT_FN_ATTRS | _mm_cvtsd_ss (__m128 __a, __m128d __b)
| Converts the lower double-precision floating-point element of a 128-bit vector of [2 x double], in the second parameter, into a single-precision floating-point value, returned in the lower 32 bits of a 128-bit vector of [4 x float]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cvtsi32_sd (__m128d __a, int __b)
| Converts a 32-bit signed integer value, in the second parameter, into a double-precision floating-point value, returned in the lower 64 bits of a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_cvtss_sd (__m128d __a, __m128 __b)
| Converts the lower single-precision floating-point element of a 128-bit vector of [4 x float], in the second parameter, into a double-precision floating-point value, returned in the lower 64 bits of a 128-bit vector of [2 x double]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cvttpd_epi32 (__m128d __a)
| Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in the lower 64 bits of a 128-bit vector of [4 x i32]. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_cvttsd_si32 (__m128d __a)
| Converts the low-order element of a [2 x double] vector into a 32-bit signed integer value, truncating the result when it is inexact. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX | _mm_cvtpd_pi32 (__m128d __a)
| Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in a 64-bit vector of [2 x i32]. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX | _mm_cvttpd_pi32 (__m128d __a)
| Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in a 64-bit vector of [2 x i32]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS_MMX | _mm_cvtpi32_pd (__m64 __a)
| Converts the two signed 32-bit integer elements of a 64-bit vector of [2 x i32] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double]. More...
static __inline__ double __DEFAULT_FN_ATTRS | _mm_cvtsd_f64 (__m128d __a)
| Returns the low-order element of a 128-bit vector of [2 x double] as a double-precision floating-point value. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_load_pd (double const *__dp)
| Loads a 128-bit floating-point vector of [2 x double] from an aligned memory location. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_load1_pd (double const *__dp)
| Loads a double-precision floating-point value from a specified memory location and duplicates it to both vector elements of a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_loadr_pd (double const *__dp)
| Loads two double-precision values, in reverse order, from an aligned memory location into a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_loadu_pd (double const *__dp)
| Loads a 128-bit floating-point vector of [2 x double] from an unaligned memory location. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_loadu_si64 (void const *__a)
| Loads a 64-bit integer value to the low element of a 128-bit integer vector and clears the upper element. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_loadu_si32 (void const *__a)
| Loads a 32-bit integer value to the low element of a 128-bit integer vector and clears the upper element. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_loadu_si16 (void const *__a)
| Loads a 16-bit integer value to the low element of a 128-bit integer vector and clears the upper element. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_load_sd (double const *__dp)
| Loads a 64-bit double-precision value to the low element of a 128-bit integer vector and clears the upper element. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_loadh_pd (__m128d __a, double const *__dp)
| Loads a double-precision value into the high-order bits of a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_loadl_pd (__m128d __a, double const *__dp)
| Loads a double-precision value into the low-order bits of a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_undefined_pd (void)
| Constructs a 128-bit floating-point vector of [2 x double] with unspecified content. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_set_sd (double __w)
| Constructs a 128-bit floating-point vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_set1_pd (double __w)
| Constructs a 128-bit floating-point vector of [2 x double], with each of the two double-precision floating-point vector elements set to the specified double-precision floating-point value. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_set_pd1 (double __w)
| Constructs a 128-bit floating-point vector of [2 x double], with each of the two double-precision floating-point vector elements set to the specified double-precision floating-point value. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_set_pd (double __w, double __x)
| Constructs a 128-bit floating-point vector of [2 x double] initialized with the specified double-precision floating-point values. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_setr_pd (double __w, double __x)
| Constructs a 128-bit floating-point vector of [2 x double], initialized in reverse order with the specified double-precision floating-point values. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_setzero_pd (void)
| Constructs a 128-bit floating-point vector of [2 x double] initialized to zero. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_move_sd (__m128d __a, __m128d __b)
| Constructs a 128-bit floating-point vector of [2 x double]. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_store_sd (double *__dp, __m128d __a)
| Stores the lower 64 bits of a 128-bit vector of [2 x double] to a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_store_pd (double *__dp, __m128d __a)
| Moves packed double-precision values from a 128-bit vector of [2 x double] to a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_store1_pd (double *__dp, __m128d __a)
| Moves the lower 64 bits of a 128-bit vector of [2 x double] twice to the upper and lower 64 bits of a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_store_pd1 (double *__dp, __m128d __a)
| Moves the lower 64 bits of a 128-bit vector of [2 x double] twice to the upper and lower 64 bits of a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeu_pd (double *__dp, __m128d __a)
| Stores a 128-bit vector of [2 x double] into an unaligned memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storer_pd (double *__dp, __m128d __a)
| Stores two double-precision values, in reverse order, from a 128-bit vector of [2 x double] to a 16-byte aligned memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeh_pd (double *__dp, __m128d __a)
| Stores the upper 64 bits of a 128-bit vector of [2 x double] to a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storel_pd (double *__dp, __m128d __a)
| Stores the lower 64 bits of a 128-bit vector of [2 x double] to a memory location. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_add_epi8 (__m128i __a, __m128i __b)
| Adds the corresponding elements of two 128-bit vectors of [16 x i8], saving the lower 8 bits of each sum in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_add_epi16 (__m128i __a, __m128i __b)
| Adds the corresponding elements of two 128-bit vectors of [8 x i16], saving the lower 16 bits of each sum in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_add_epi32 (__m128i __a, __m128i __b)
| Adds the corresponding elements of two 128-bit vectors of [4 x i32], saving the lower 32 bits of each sum in the corresponding element of a 128-bit result vector of [4 x i32]. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX | _mm_add_si64 (__m64 __a, __m64 __b)
| Adds two signed or unsigned 64-bit integer values, returning the lower 64 bits of the sum. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_add_epi64 (__m128i __a, __m128i __b)
| Adds the corresponding elements of two 128-bit vectors of [2 x i64], saving the lower 64 bits of each sum in the corresponding element of a 128-bit result vector of [2 x i64]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_adds_epi8 (__m128i __a, __m128i __b)
| Adds, with saturation, the corresponding elements of two 128-bit signed [16 x i8] vectors, saving each sum in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_adds_epi16 (__m128i __a, __m128i __b)
| Adds, with saturation, the corresponding elements of two 128-bit signed [8 x i16] vectors, saving each sum in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_adds_epu8 (__m128i __a, __m128i __b)
| Adds, with saturation, the corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving each sum in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_adds_epu16 (__m128i __a, __m128i __b)
| Adds, with saturation, the corresponding elements of two 128-bit unsigned [8 x i16] vectors, saving each sum in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_avg_epu8 (__m128i __a, __m128i __b)
| Computes the rounded averages of corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving each result in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_avg_epu16 (__m128i __a, __m128i __b)
| Computes the rounded averages of corresponding elements of two 128-bit unsigned [8 x i16] vectors, saving each result in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_madd_epi16 (__m128i __a, __m128i __b)
| Multiplies the corresponding elements of two 128-bit signed [8 x i16] vectors, producing eight intermediate 32-bit signed integer products, and adds the consecutive pairs of 32-bit products to form a 128-bit signed [4 x i32] vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_max_epi16 (__m128i __a, __m128i __b)
| Compares corresponding elements of two 128-bit signed [8 x i16] vectors, saving the greater value from each comparison in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_max_epu8 (__m128i __a, __m128i __b)
| Compares corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving the greater value from each comparison in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_min_epi16 (__m128i __a, __m128i __b)
| Compares corresponding elements of two 128-bit signed [8 x i16] vectors, saving the smaller value from each comparison in the corresponding element of a 128-bit result vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_min_epu8 (__m128i __a, __m128i __b)
| Compares corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving the smaller value from each comparison in the corresponding element of a 128-bit result vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_mulhi_epi16 (__m128i __a, __m128i __b)
| Multiplies the corresponding elements of two signed [8 x i16] vectors, saving the upper 16 bits of each 32-bit product in the corresponding element of a 128-bit signed [8 x i16] result vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_mulhi_epu16 (__m128i __a, __m128i __b)
| Multiplies the corresponding elements of two unsigned [8 x i16] vectors, saving the upper 16 bits of each 32-bit product in the corresponding element of a 128-bit unsigned [8 x i16] result vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_mullo_epi16 (__m128i __a, __m128i __b)
| Multiplies the corresponding elements of two signed [8 x i16] vectors, saving the lower 16 bits of each 32-bit product in the corresponding element of a 128-bit signed [8 x i16] result vector. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX | _mm_mul_su32 (__m64 __a, __m64 __b)
| Multiplies 32-bit unsigned integer values contained in the lower bits of the two 64-bit integer vectors and returns the 64-bit unsigned product. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_mul_epu32 (__m128i __a, __m128i __b)
| Multiplies 32-bit unsigned integer values contained in the lower bits of the corresponding elements of two [2 x i64] vectors, and returns the 64-bit products in the corresponding elements of a [2 x i64] vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sad_epu8 (__m128i __a, __m128i __b)
| Computes the absolute differences of corresponding 8-bit integer values in two 128-bit vectors. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sub_epi8 (__m128i __a, __m128i __b)
| Subtracts the corresponding 8-bit integer values in the operands. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sub_epi16 (__m128i __a, __m128i __b)
| Subtracts the corresponding 16-bit integer values in the operands. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sub_epi32 (__m128i __a, __m128i __b)
| Subtracts the corresponding 32-bit integer values in the operands. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX | _mm_sub_si64 (__m64 __a, __m64 __b)
| Subtracts signed or unsigned 64-bit integer values and writes the difference to the corresponding bits in the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sub_epi64 (__m128i __a, __m128i __b)
| Subtracts the corresponding elements of two [2 x i64] vectors. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_subs_epi8 (__m128i __a, __m128i __b)
| Subtracts corresponding 8-bit signed integer values in the input and returns the differences in the corresponding bytes in the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_subs_epi16 (__m128i __a, __m128i __b)
| Subtracts corresponding 16-bit signed integer values in the input and returns the differences in the corresponding bytes in the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_subs_epu8 (__m128i __a, __m128i __b)
| Subtracts corresponding 8-bit unsigned integer values in the input and returns the differences in the corresponding bytes in the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_subs_epu16 (__m128i __a, __m128i __b)
| Subtracts corresponding 16-bit unsigned integer values in the input and returns the differences in the corresponding bytes in the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_and_si128 (__m128i __a, __m128i __b)
| Performs a bitwise AND of two 128-bit integer vectors. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_andnot_si128 (__m128i __a, __m128i __b)
| Performs a bitwise AND of two 128-bit integer vectors, using the one's complement of the values contained in the first source operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_or_si128 (__m128i __a, __m128i __b)
| Performs a bitwise OR of two 128-bit integer vectors. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_xor_si128 (__m128i __a, __m128i __b)
| Performs a bitwise exclusive OR of two 128-bit integer vectors. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_slli_epi16 (__m128i __a, int __count)
| Left-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sll_epi16 (__m128i __a, __m128i __count)
| Left-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_slli_epi32 (__m128i __a, int __count)
| Left-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sll_epi32 (__m128i __a, __m128i __count)
| Left-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_slli_epi64 (__m128i __a, int __count)
| Left-shifts each 64-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sll_epi64 (__m128i __a, __m128i __count)
| Left-shifts each 64-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srai_epi16 (__m128i __a, int __count)
| Right-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sra_epi16 (__m128i __a, __m128i __count)
| Right-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srai_epi32 (__m128i __a, int __count)
| Right-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_sra_epi32 (__m128i __a, __m128i __count)
| Right-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srli_epi16 (__m128i __a, int __count)
| Right-shifts each of 16-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srl_epi16 (__m128i __a, __m128i __count)
| Right-shifts each of 16-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srli_epi32 (__m128i __a, int __count)
| Right-shifts each of 32-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srl_epi32 (__m128i __a, __m128i __count)
| Right-shifts each of 32-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srli_epi64 (__m128i __a, int __count)
| Right-shifts each of 64-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_srl_epi64 (__m128i __a, __m128i __count)
| Right-shifts each of 64-bit values in the 128-bit integer vector operand by the specified number of bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpeq_epi8 (__m128i __a, __m128i __b)
| Compares each of the corresponding 8-bit values of the 128-bit integer vectors for equality. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpeq_epi16 (__m128i __a, __m128i __b)
| Compares each of the corresponding 16-bit values of the 128-bit integer vectors for equality. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpeq_epi32 (__m128i __a, __m128i __b)
| Compares each of the corresponding 32-bit values of the 128-bit integer vectors for equality. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpgt_epi8 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 8-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpgt_epi16 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 16-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmpgt_epi32 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 32-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmplt_epi8 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 8-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmplt_epi16 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 16-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cmplt_epi32 (__m128i __a, __m128i __b)
| Compares each of the corresponding signed 32-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand. More...
static __inline__ __m128 __DEFAULT_FN_ATTRS | _mm_cvtepi32_ps (__m128i __a)
| Converts a vector of [4 x i32] into a vector of [4 x float]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cvtps_epi32 (__m128 __a)
| Converts a vector of [4 x float] into a vector of [4 x i32]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cvttps_epi32 (__m128 __a)
| Converts a vector of [4 x float] into a vector of [4 x i32], truncating the result when it is inexact. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_cvtsi32_si128 (int __a)
| Returns a vector of [4 x i32] where the lowest element is the input operand and the remaining elements are zero. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_cvtsi128_si32 (__m128i __a)
| Moves the least significant 32 bits of a vector of [4 x i32] to a 32-bit signed integer value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_load_si128 (__m128i const *__p)
| Moves packed integer values from an aligned 128-bit memory location to elements in a 128-bit integer vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_loadu_si128 (__m128i_u const *__p)
| Moves packed integer values from an unaligned 128-bit memory location to elements in a 128-bit integer vector. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_loadl_epi64 (__m128i_u const *__p)
| Returns a vector of [2 x i64] where the lower element is taken from the lower element of the operand, and the upper element is zero. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_undefined_si128 (void)
| Generates a 128-bit vector of [4 x i32] with unspecified content. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set_epi64x (long long __q1, long long __q0)
| Initializes both 64-bit values in a 128-bit vector of [2 x i64] with the specified 64-bit integer values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set_epi64 (__m64 __q1, __m64 __q0)
| Initializes both 64-bit values in a 128-bit vector of [2 x i64] with the specified 64-bit integer values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set_epi32 (int __i3, int __i2, int __i1, int __i0)
| Initializes the 32-bit values in a 128-bit vector of [4 x i32] with the specified 32-bit integer values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set_epi16 (short __w7, short __w6, short __w5, short __w4, short __w3, short __w2, short __w1, short __w0)
| Initializes the 16-bit values in a 128-bit vector of [8 x i16] with the specified 16-bit integer values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set_epi8 (char __b15, char __b14, char __b13, char __b12, char __b11, char __b10, char __b9, char __b8, char __b7, char __b6, char __b5, char __b4, char __b3, char __b2, char __b1, char __b0)
| Initializes the 8-bit values in a 128-bit vector of [16 x i8] with the specified 8-bit integer values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set1_epi64x (long long __q)
| Initializes both values in a 128-bit integer vector with the specified 64-bit integer value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set1_epi64 (__m64 __q)
| Initializes both values in a 128-bit vector of [2 x i64] with the specified 64-bit value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set1_epi32 (int __i)
| Initializes all values in a 128-bit vector of [4 x i32] with the specified 32-bit value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set1_epi16 (short __w)
| Initializes all values in a 128-bit vector of [8 x i16] with the specified 16-bit value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_set1_epi8 (char __b)
| Initializes all values in a 128-bit vector of [16 x i8] with the specified 8-bit value. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_setr_epi64 (__m64 __q0, __m64 __q1)
| Constructs a 128-bit integer vector, initialized in reverse order with the specified 64-bit integral values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_setr_epi32 (int __i0, int __i1, int __i2, int __i3)
| Constructs a 128-bit integer vector, initialized in reverse order with the specified 32-bit integral values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_setr_epi16 (short __w0, short __w1, short __w2, short __w3, short __w4, short __w5, short __w6, short __w7)
| Constructs a 128-bit integer vector, initialized in reverse order with the specified 16-bit integral values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_setr_epi8 (char __b0, char __b1, char __b2, char __b3, char __b4, char __b5, char __b6, char __b7, char __b8, char __b9, char __b10, char __b11, char __b12, char __b13, char __b14, char __b15)
| Constructs a 128-bit integer vector, initialized in reverse order with the specified 8-bit integral values. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_setzero_si128 (void)
| Creates a 128-bit integer vector initialized to zero. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_store_si128 (__m128i *__p, __m128i __b)
| Stores a 128-bit integer vector to a memory location aligned on a 128-bit boundary. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeu_si128 (__m128i_u *__p, __m128i __b)
| Stores a 128-bit integer vector to an unaligned memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeu_si64 (void *__p, __m128i __b)
| Stores a 64-bit integer value from the low element of a 128-bit integer vector. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeu_si32 (void *__p, __m128i __b)
| Stores a 32-bit integer value from the low element of a 128-bit integer vector. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storeu_si16 (void *__p, __m128i __b)
| Stores a 16-bit integer value from the low element of a 128-bit integer vector. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_maskmoveu_si128 (__m128i __d, __m128i __n, char *__p)
| Moves bytes selected by the mask from the first operand to the specified unaligned memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_storel_epi64 (__m128i_u *__p, __m128i __a)
| Stores the lower 64 bits of a 128-bit integer vector of [2 x i64] to a memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_stream_pd (double *__p, __m128d __a)
| Stores a 128-bit floating point vector of [2 x double] to a 128-bit aligned memory location. More...
static __inline__ void __DEFAULT_FN_ATTRS | _mm_stream_si128 (__m128i *__p, __m128i __a)
| Stores a 128-bit integer vector to a 128-bit aligned memory location. More...
static __inline__ void | __attribute__ ((__always_inline__, __nodebug__, __target__("sse2"))) _mm_stream_si32(int *__p
| Stores a 32-bit integer value in the specified memory location. More...
void | _mm_clflush (void const *__p)
| The cache line containing __p is flushed and invalidated from all caches in the coherency domain. More...
void | _mm_lfence (void)
| Forces strong memory ordering (serialization) between load instructions preceding this instruction and load instructions following this instruction, ensuring the system completes all previous loads before executing subsequent loads. More...
void | _mm_mfence (void)
| Forces strong memory ordering (serialization) between load and store instructions preceding this instruction and load and store instructions following this instruction, ensuring that the system completes all previous memory accesses before executing subsequent memory accesses. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_packs_epi16 (__m128i __a, __m128i __b)
| Converts 16-bit signed integers from both 128-bit integer vector operands into 8-bit signed integers, and packs the results into the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_packs_epi32 (__m128i __a, __m128i __b)
| Converts 32-bit signed integers from both 128-bit integer vector operands into 16-bit signed integers, and packs the results into the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_packus_epi16 (__m128i __a, __m128i __b)
| Converts 16-bit signed integers from both 128-bit integer vector operands into 8-bit unsigned integers, and packs the results into the destination. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_movemask_epi8 (__m128i __a)
| Copies the values of the most significant bits from each 8-bit element in a 128-bit integer vector of [16 x i8] to create a 16-bit mask value, zero-extends the value, and writes it to the destination. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpackhi_epi8 (__m128i __a, __m128i __b)
| Unpacks the high-order (index 8-15) values from two 128-bit vectors of [16 x i8] and interleaves them into a 128-bit vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpackhi_epi16 (__m128i __a, __m128i __b)
| Unpacks the high-order (index 4-7) values from two 128-bit vectors of [8 x i16] and interleaves them into a 128-bit vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpackhi_epi32 (__m128i __a, __m128i __b)
| Unpacks the high-order (index 2,3) values from two 128-bit vectors of [4 x i32] and interleaves them into a 128-bit vector of [4 x i32]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpackhi_epi64 (__m128i __a, __m128i __b)
| Unpacks the high-order 64-bit elements from two 128-bit vectors of [2 x i64] and interleaves them into a 128-bit vector of [2 x i64]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpacklo_epi8 (__m128i __a, __m128i __b)
| Unpacks the low-order (index 0-7) values from two 128-bit vectors of [16 x i8] and interleaves them into a 128-bit vector of [16 x i8]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpacklo_epi16 (__m128i __a, __m128i __b)
| Unpacks the low-order (index 0-3) values from each of the two 128-bit vectors of [8 x i16] and interleaves them into a 128-bit vector of [8 x i16]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpacklo_epi32 (__m128i __a, __m128i __b)
| Unpacks the low-order (index 0,1) values from two 128-bit vectors of [4 x i32] and interleaves them into a 128-bit vector of [4 x i32]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_unpacklo_epi64 (__m128i __a, __m128i __b)
| Unpacks the low-order 64-bit elements from two 128-bit vectors of [2 x i64] and interleaves them into a 128-bit vector of [2 x i64]. More...
static __inline__ __m64 __DEFAULT_FN_ATTRS | _mm_movepi64_pi64 (__m128i __a)
| Returns the lower 64 bits of a 128-bit integer vector as a 64-bit integer. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_movpi64_epi64 (__m64 __a)
| Moves the 64-bit operand to a 128-bit integer vector, zeroing the upper bits. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_move_epi64 (__m128i __a)
| Moves the lower 64 bits of a 128-bit integer vector to a 128-bit integer vector, zeroing the upper bits. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_unpackhi_pd (__m128d __a, __m128d __b)
| Unpacks the high-order 64-bit elements from two 128-bit vectors of [2 x double] and interleaves them into a 128-bit vector of [2 x double]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_unpacklo_pd (__m128d __a, __m128d __b)
| Unpacks the low-order 64-bit elements from two 128-bit vectors of [2 x double] and interleaves them into a 128-bit vector of [2 x double]. More...
static __inline__ int __DEFAULT_FN_ATTRS | _mm_movemask_pd (__m128d __a)
| Extracts the sign bits of the double-precision values in the 128-bit vector of [2 x double], zero-extends the value, and writes it to the low-order bits of the destination. More...
static __inline__ __m128 __DEFAULT_FN_ATTRS | _mm_castpd_ps (__m128d __a)
| Casts a 128-bit floating-point vector of [2 x double] into a 128-bit floating-point vector of [4 x float]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_castpd_si128 (__m128d __a)
| Casts a 128-bit floating-point vector of [2 x double] into a 128-bit integer vector. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_castps_pd (__m128 __a)
| Casts a 128-bit floating-point vector of [4 x float] into a 128-bit floating-point vector of [2 x double]. More...
static __inline__ __m128i __DEFAULT_FN_ATTRS | _mm_castps_si128 (__m128 __a)
| Casts a 128-bit floating-point vector of [4 x float] into a 128-bit integer vector. More...
static __inline__ __m128 __DEFAULT_FN_ATTRS | _mm_castsi128_ps (__m128i __a)
| Casts a 128-bit integer vector into a 128-bit floating-point vector of [4 x float]. More...
static __inline__ __m128d __DEFAULT_FN_ATTRS | _mm_castsi128_pd (__m128i __a)
| Casts a 128-bit integer vector into a 128-bit floating-point vector of [2 x double]. More...
void | _mm_pause (void)
| Indicates that a spin loop is being executed for the purposes of optimizing power consumption during the loop. More...

## Variables
static __inline__ void int | __a

## Macro Definition Documentation

## ◆ __DEFAULT_FN_ATTRS

#define __DEFAULT_FN_ATTRS __attribute__((__always_inline__, __nodebug__, __target__("sse2"), __min_vector_width__(128)))

Definition at line 37 of file emmintrin.h.

Referenced by _mm_add_epi16(), _mm_add_epi64(), _mm_add_epi8(), _mm_add_pd(), _mm_add_sd(), _mm_add_si64(), _mm_adds_epi16(), _mm_adds_epi8(), _mm_adds_epu16(), _mm_adds_epu8(), _mm_and_pd(), _mm_and_si128(), _mm_andnot_pd(), _mm_andnot_si128(), _mm_avg_epu16(), _mm_avg_epu8(), _mm_castpd_ps(), _mm_castpd_si128(), _mm_castps_pd(), _mm_castps_si128(), _mm_castsi128_ps(), _mm_cmpeq_epi16(), _mm_cmpeq_epi32(), _mm_cmpeq_epi8(), _mm_cmpeq_pd(), _mm_cmpeq_sd(), _mm_cmpge_pd(), _mm_cmpge_sd(), _mm_cmpgt_epi16(), _mm_cmpgt_epi32(), _mm_cmpgt_epi8(), _mm_cmpgt_pd(), _mm_cmpgt_sd(), _mm_cmple_pd(), _mm_cmple_sd(), _mm_cmplt_epi16(), _mm_cmplt_epi32(), _mm_cmplt_epi8(), _mm_cmplt_pd(), _mm_cmplt_sd(), _mm_cmpneq_pd(), _mm_cmpneq_sd(), _mm_cmpnge_pd(), _mm_cmpnge_sd(), _mm_cmpngt_pd(), _mm_cmpngt_sd(), _mm_cmpnle_pd(), _mm_cmpnle_sd(), _mm_cmpnlt_pd(), _mm_cmpnlt_sd(), _mm_cmpord_pd(), _mm_cmpord_sd(), _mm_cmpunord_pd(), _mm_cmpunord_sd(), _mm_comieq_sd(), _mm_comige_sd(), _mm_comigt_sd(), _mm_comile_sd(), _mm_comilt_sd(), _mm_comineq_sd(), _mm_cvtepi32_pd(), _mm_cvtepi32_ps(), _mm_cvtpd_epi32(), _mm_cvtpd_ps(), _mm_cvtpi32_pd(), _mm_cvtps_epi32(), _mm_cvtps_pd(), _mm_cvtsd_f64(), _mm_cvtsd_si32(), _mm_cvtsd_ss(), _mm_cvtsi128_si32(), _mm_cvtsi32_sd(), _mm_cvtsi32_si128(), _mm_cvtss_sd(), _mm_cvttpd_epi32(), _mm_cvttps_epi32(), _mm_div_pd(), _mm_div_sd(), _mm_load_pd(), _mm_load_sd(), _mm_load_si128(), _mm_loadh_pd(), _mm_loadl_epi64(), _mm_loadl_pd(), _mm_loadr_pd(), _mm_loadu_pd(), _mm_loadu_si128(), _mm_loadu_si16(), _mm_loadu_si32(), _mm_loadu_si64(), _mm_madd_epi16(), _mm_maskmoveu_si128(), _mm_max_epi16(), _mm_max_epu8(), _mm_max_pd(), _mm_max_sd(), _mm_min_epi16(), _mm_min_epu8(), _mm_min_pd(), _mm_min_sd(), _mm_move_epi64(), _mm_move_sd(), _mm_movepi64_pi64(), _mm_movpi64_epi64(), _mm_mul_epu32(), _mm_mul_pd(), _mm_mul_sd(), _mm_mul_su32(), _mm_mulhi_epi16(), _mm_mulhi_epu16(), _mm_or_pd(), _mm_or_si128(), _mm_packs_epi16(), _mm_packs_epi32(), _mm_sad_epu8(), _mm_set1_epi16(), _mm_set1_epi32(), _mm_set1_epi64(), _mm_set1_epi64x(), _mm_set1_epi8(), _mm_set1_pd(), _mm_set_epi16(), _mm_set_epi32(), _mm_set_epi64(), _mm_set_epi64x(), _mm_set_epi8(), _mm_set_pd(), _mm_set_pd1(), _mm_set_sd(), _mm_setr_epi16(), _mm_setr_epi32(), _mm_setr_epi64(), _mm_setr_epi8(), _mm_setr_pd(), _mm_setzero_pd(), _mm_setzero_si128(), _mm_sll_epi16(), _mm_sll_epi32(), _mm_sll_epi64(), _mm_slli_epi16(), _mm_slli_epi32(), _mm_slli_epi64(), _mm_sqrt_pd(), _mm_sqrt_sd(), _mm_sra_epi16(), _mm_srai_epi16(), _mm_srai_epi32(), _mm_srl_epi16(), _mm_srl_epi32(), _mm_srl_epi64(), _mm_srli_epi16(), _mm_srli_epi32(), _mm_srli_epi64(), _mm_store1_pd(), _mm_store_pd(), _mm_store_pd1(), _mm_store_sd(), _mm_store_si128(), _mm_storeh_pd(), _mm_storel_epi64(), _mm_storel_pd(), _mm_storer_pd(), _mm_storeu_pd(), _mm_storeu_si128(), _mm_storeu_si16(), _mm_storeu_si32(), _mm_storeu_si64(), _mm_stream_pd(), _mm_sub_epi16(), _mm_sub_epi64(), _mm_sub_epi8(), _mm_sub_pd(), _mm_sub_sd(), _mm_sub_si64(), _mm_subs_epi16(), _mm_subs_epi8(), _mm_subs_epu16(), _mm_subs_epu8(), _mm_ucomieq_sd(), _mm_ucomige_sd(), _mm_ucomigt_sd(), _mm_ucomile_sd(), _mm_ucomilt_sd(), _mm_ucomineq_sd(), _mm_undefined_pd(), _mm_undefined_si128(), _mm_unpackhi_epi16(), _mm_unpackhi_epi32(), _mm_unpackhi_epi64(), _mm_unpackhi_epi8(), _mm_unpackhi_pd(), _mm_unpacklo_epi16(), _mm_unpacklo_epi32(), _mm_unpacklo_epi64(), _mm_unpacklo_epi8(), _mm_unpacklo_pd(), and _mm_xor_pd().

## ◆ __DEFAULT_FN_ATTRS_MMX

#define __DEFAULT_FN_ATTRS_MMX __attribute__((__always_inline__, __nodebug__, __target__("mmx,sse2"), __min_vector_width__(64)))

Definition at line 38 of file emmintrin.h.

Referenced by _mm_add_epi32(), _mm_cvtpd_pi32(), _mm_cvttpd_pi32(), _mm_cvttsd_si32(), _mm_mullo_epi16(), and _mm_sub_epi32().

## ◆ _mm_bslli_si128

#define _mm_bslli_si128 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_pslldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))

Definition at line 2823 of file emmintrin.h.

## ◆ _mm_bsrli_si128

#define _mm_bsrli_si128 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_psrldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))

Definition at line 3040 of file emmintrin.h.

## ◆ _MM_DENORMALS_ZERO_MASK

#define _MM_DENORMALS_ZERO_MASK (0x0040)

Definition at line 4976 of file emmintrin.h.

## ◆ _MM_DENORMALS_ZERO_OFF

#define _MM_DENORMALS_ZERO_OFF (0x0000)

Definition at line 4974 of file emmintrin.h.

## ◆ _MM_DENORMALS_ZERO_ON

#define _MM_DENORMALS_ZERO_ON (0x0040)

Definition at line 4973 of file emmintrin.h.

## ◆ _mm_extract_epi16

#define _mm_extract_epi16 | ( |  | a,
|  |  | imm
| ) |  |

Value:
(int)(unsigned short)__builtin_ia32_vec_ext_v8hi((__v8hi)(__m128i)(a), \
(int)(imm))

Extracts 16 bits from a 128-bit integer vector of [8 x i16], using the immediate-value parameter as a selector.

This intrinsic corresponds to the `VPEXTRW / PEXTRW` instruction.

Parameters

  __a | A 128-bit integer vector.
  __imm | An immediate value. Bits [2:0] selects values from __a to be assigned to bits[15:0] of the result. 000: assign values from bits [15:0] of __a. 001: assign values from bits [31:16] of __a. 010: assign values from bits [47:32] of __a. 011: assign values from bits [63:48] of __a. 100: assign values from bits [79:64] of __a. 101: assign values from bits [95:80] of __a. 110: assign values from bits [111:96] of __a. 111: assign values from bits [127:112] of __a.

Returns
  An integer, whose lower 16 bits are selected from the 128-bit integer vector parameter and the remaining bits are assigned zeros.

Definition at line 4358 of file emmintrin.h.

## ◆ _MM_GET_DENORMALS_ZERO_MODE

#define _MM_GET_DENORMALS_ZERO_MODE | ( |  | ) | (_mm_getcsr() & _MM_DENORMALS_ZERO_MASK)

Definition at line 4978 of file emmintrin.h.

## ◆ _mm_insert_epi16

#define _mm_insert_epi16 | ( |  | a,
|  |  | b,
|  |  | imm
| ) |  |

Value:
(__m128i)__builtin_ia32_vec_set_v8hi((__v8hi)(__m128i)(a), (int)(b), \
(int)(imm))

Constructs a 128-bit integer vector by first making a copy of the 128-bit integer vector parameter, and then inserting the lower 16 bits of an integer parameter into an offset specified by the immediate-value parameter.

This intrinsic corresponds to the `VPINSRW / PINSRW` instruction.

Parameters

  __a | A 128-bit integer vector of [8 x i16]. This vector is copied to the result and then one of the eight elements in the result is replaced by the lower 16 bits of __b.
  __b | An integer. The lower 16 bits of this parameter are written to the result beginning at an offset specified by __imm.
  __imm | An immediate value specifying the bit offset in the result at which the lower 16 bits of __b are written.

Returns
  A 128-bit integer vector containing the constructed values.

Definition at line 4382 of file emmintrin.h.

## ◆ _mm_load_pd1

#define _mm_load_pd1 | ( |  | dp | ) | _mm_load1_pd(dp)

Definition at line 1606 of file emmintrin.h.

## ◆ _MM_SET_DENORMALS_ZERO_MODE

#define _MM_SET_DENORMALS_ZERO_MODE | ( |  | x | ) | (_mm_setcsr((_mm_getcsr() & ~_MM_DENORMALS_ZERO_MASK) | (x)))

Definition at line 4979 of file emmintrin.h.

## ◆ _MM_SHUFFLE2

#define _MM_SHUFFLE2 | ( |  | x,
|  |  | y
| ) |  | (((x) << 1) | (y))

Definition at line 4971 of file emmintrin.h.

## ◆ _mm_shuffle_epi32

#define _mm_shuffle_epi32 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_pshufd((__v4si)(__m128i)(a), (int)(imm))

Constructs a 128-bit integer vector by shuffling four 32-bit elements of a 128-bit integer vector parameter, using the immediate-value parameter as a specifier.

__m128i _mm_shuffle_epi32(__m128i a, const int imm);

This intrinsic corresponds to the `VPSHUFD / PSHUFD` instruction.

Parameters

  a | A 128-bit integer vector containing the values to be copied.
  imm | An immediate value containing an 8-bit value specifying which elements to copy from a. The destinations within the 128-bit destination are assigned values as follows: Bits [1:0] are used to assign values to bits [31:0] of the result. Bits [3:2] are used to assign values to bits [63:32] of the result. Bits [5:4] are used to assign values to bits [95:64] of the result. Bits [7:6] are used to assign values to bits [127:96] of the result. Bit value assignments: 00: assign values from bits [31:0] of a. 01: assign values from bits [63:32] of a. 10: assign values from bits [95:64] of a. 11: assign values from bits [127:96] of a.

Returns
  A 128-bit integer vector containing the shuffled values.

Definition at line 4432 of file emmintrin.h.

## ◆ _mm_shuffle_pd

#define _mm_shuffle_pd | ( |  | a,
|  |  | b,
|  |  | i
| ) |  |

Value:
(__m128d)__builtin_ia32_shufpd((__v2df)(__m128d)(a), (__v2df)(__m128d)(b), \
(int)(i))

Constructs a 128-bit floating-point vector of [2 x double] from two 128-bit vector parameters of [2 x double], using the immediate-value parameter as a specifier.

__m128d _mm_shuffle_pd(__m128d a, __m128d b, const int i);

This intrinsic corresponds to the `VSHUFPD / SHUFPD` instruction.

Parameters

  a | A 128-bit vector of [2 x double].
  b | A 128-bit vector of [2 x double].
  i | An 8-bit immediate value. The least significant two bits specify which elements to copy from a and b: Bit[0] = 0: lower element of a copied to lower element of result. Bit[0] = 1: upper element of a copied to lower element of result. Bit[1] = 0: lower element of b copied to upper element of result. Bit[1] = 1: upper element of b copied to upper element of result.

Returns
  A 128-bit vector of [2 x double] containing the shuffled values.

Definition at line 4846 of file emmintrin.h.

## ◆ _mm_shufflehi_epi16

#define _mm_shufflehi_epi16 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_pshufhw((__v8hi)(__m128i)(a), (int)(imm))

Constructs a 128-bit integer vector by shuffling four upper 16-bit elements of a 128-bit integer vector of [8 x i16], using the immediate value parameter as a specifier.

__m128i _mm_shufflehi_epi16(__m128i a, const int imm);

This intrinsic corresponds to the `VPSHUFHW / PSHUFHW` instruction.

Parameters

  a | A 128-bit integer vector of [8 x i16]. Bits [63:0] are copied to bits [63:0] of the result.
  imm | An 8-bit immediate value specifying which elements to copy from a. Bits[1:0] are used to assign values to bits [79:64] of the result. Bits[3:2] are used to assign values to bits [95:80] of the result. Bits[5:4] are used to assign values to bits [111:96] of the result. Bits[7:6] are used to assign values to bits [127:112] of the result. Bit value assignments: 00: assign values from bits [79:64] of a. 01: assign values from bits [95:80] of a. 10: assign values from bits [111:96] of a. 11: assign values from bits [127:112] of a.

Returns
  A 128-bit integer vector containing the shuffled values.

Definition at line 4492 of file emmintrin.h.

## ◆ _mm_shufflelo_epi16

#define _mm_shufflelo_epi16 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_pshuflw((__v8hi)(__m128i)(a), (int)(imm))

Constructs a 128-bit integer vector by shuffling four lower 16-bit elements of a 128-bit integer vector of [8 x i16], using the immediate value parameter as a specifier.

__m128i _mm_shufflelo_epi16(__m128i a, const int imm);

This intrinsic corresponds to the `VPSHUFLW / PSHUFLW` instruction.

Parameters

  a | A 128-bit integer vector of [8 x i16]. Bits [127:64] are copied to bits [127:64] of the result.
  imm | An 8-bit immediate value specifying which elements to copy from a. Bits[1:0] are used to assign values to bits [15:0] of the result. Bits[3:2] are used to assign values to bits [31:16] of the result. Bits[5:4] are used to assign values to bits [47:32] of the result. Bits[7:6] are used to assign values to bits [63:48] of the result. Bit value assignments: 00: assign values from bits [15:0] of a. 01: assign values from bits [31:16] of a. 10: assign values from bits [47:32] of a. 11: assign values from bits [63:48] of a.

Returns
  A 128-bit integer vector containing the shuffled values.

Definition at line 4462 of file emmintrin.h.

## ◆ _mm_slli_si128

#define _mm_slli_si128 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_pslldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))

Left-shifts the 128-bit integer vector operand by the specified number of bytes.

Low-order bits are cleared.

__m128i _mm_slli_si128(__m128i a, const int imm);

This intrinsic corresponds to the `VPSLLDQ / PSLLDQ` instruction.

Parameters

  a | A 128-bit integer vector containing the source operand.
  imm | An immediate value specifying the number of bytes to left-shift operand a.

Returns
  A 128-bit integer vector containing the left-shifted value.

Definition at line 2820 of file emmintrin.h.

## ◆ _mm_srli_si128

#define _mm_srli_si128 | ( |  | a,
|  |  | imm
| ) |  | (__m128i)__builtin_ia32_psrldqi128_byteshift((__v2di)(__m128i)(a), (int)(imm))

Right-shifts the 128-bit integer vector operand by the specified number of bytes.

High-order bits are cleared.

__m128i _mm_srli_si128(__m128i a, const int imm);

This intrinsic corresponds to the `VPSRLDQ / PSRLDQ` instruction.

Parameters

  a | A 128-bit integer vector containing the source operand.
  imm | An immediate value specifying the number of bytes to right-shift operand a.

Returns
  A 128-bit integer vector containing the right-shifted value.

Definition at line 3037 of file emmintrin.h.

## Typedef Documentation

## ◆ __attribute__

typedef signed char __v16qs __attribute__((__vector_size__(16)))

Definition at line 15 of file emmintrin.h.

## Function Documentation

## ◆ __attribute__()

static __inline__ void __attribute__ | ( | (__always_inline__, __nodebug__, __target__("sse2")) |  | ) |
| static

Stores a 32-bit integer value in the specified memory location.

To minimize caching, the data is flagged as non-temporal (unlikely to be used again soon).

This intrinsic corresponds to the `MOVNTI` instruction.

Parameters

  __p | A pointer to the 32-bit memory location used to store the value.
  __a | A 32-bit integer containing the value to be stored.

## ◆ _mm_add_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_add_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds the corresponding elements of two 128-bit vectors of [8 x i16], saving the lower 16 bits of each sum in the corresponding element of a 128-bit result vector of [8 x i16].

The integer elements of both parameters can be either signed or unsigned.

This intrinsic corresponds to the `VPADDW / PADDW` instruction.

Parameters

  __a | A 128-bit vector of [8 x i16].
  __b | A 128-bit vector of [8 x i16].

Returns
  A 128-bit vector of [8 x i16] containing the sums of both parameters.

Definition at line 2139 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_add_epi16(), and _mm_maskz_add_epi16().

## ◆ _mm_add_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_add_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds the corresponding elements of two 128-bit vectors of [4 x i32], saving the lower 32 bits of each sum in the corresponding element of a 128-bit result vector of [4 x i32].

The integer elements of both parameters can be either signed or unsigned.

This intrinsic corresponds to the `VPADDD / PADDD` instruction.

Parameters

  __a | A 128-bit vector of [4 x i32].
  __b | A 128-bit vector of [4 x i32].

Returns
  A 128-bit vector of [4 x i32] containing the sums of both parameters.

Definition at line 2161 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS_MMX.

Referenced by _mm_mask_add_epi32(), and _mm_maskz_add_epi32().

## ◆ _mm_add_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_add_epi64 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds the corresponding elements of two 128-bit vectors of [2 x i64], saving the lower 64 bits of each sum in the corresponding element of a 128-bit result vector of [2 x i64].

The integer elements of both parameters can be either signed or unsigned.

This intrinsic corresponds to the `VPADDQ / PADDQ` instruction.

Parameters

  __a | A 128-bit vector of [2 x i64].
  __b | A 128-bit vector of [2 x i64].

Returns
  A 128-bit vector of [2 x i64] containing the sums of both parameters.

Definition at line 2201 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_add_epi64(), and _mm_maskz_add_epi64().

## ◆ _mm_add_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_add_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds the corresponding elements of two 128-bit vectors of [16 x i8], saving the lower 8 bits of each sum in the corresponding element of a 128-bit result vector of [16 x i8].

The integer elements of both parameters can be either signed or unsigned.

This intrinsic corresponds to the `VPADDB / PADDB` instruction.

Parameters

  __a | A 128-bit vector of [16 x i8].
  __b | A 128-bit vector of [16 x i8].

Returns
  A 128-bit vector of [16 x i8] containing the sums of both parameters.

Definition at line 2117 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_add_epi8(), and _mm_maskz_add_epi8().

## ◆ _mm_add_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_add_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Adds two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VADDPD / ADDPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] containing the sums of both operands.

Definition at line 75 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_add_pd(), and _mm_maskz_add_pd().

## ◆ _mm_add_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_add_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Adds lower double-precision values in both operands and returns the sum in the lower 64 bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VADDSD / ADDSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the sum of the lower 64 bits of both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 56 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_add_sd(), and _mm_maskz_add_sd().

## ◆ _mm_add_si64()

static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX _mm_add_si64 | ( | __m64 | __a,
|  | __m64 | __b
| ) |  |
| static

Adds two signed or unsigned 64-bit integer values, returning the lower 64 bits of the sum.

This intrinsic corresponds to the `PADDQ` instruction.

Parameters

  __a | A 64-bit integer.
  __b | A 64-bit integer.

Returns
  A 64-bit integer containing the sum of both parameters.

Definition at line 2179 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_adds_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_adds_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds, with saturation, the corresponding elements of two 128-bit signed [8 x i16] vectors, saving each sum in the corresponding element of a 128-bit result vector of [8 x i16].

Positive sums greater than 0x7FFF are saturated to 0x7FFF. Negative sums less than 0x8000 are saturated to 0x8000.

This intrinsic corresponds to the `VPADDSW / PADDSW` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [8 x i16] vector containing the saturated sums of both parameters.

Definition at line 2244 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_adds_epi16(), and _mm_maskz_adds_epi16().

## ◆ _mm_adds_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_adds_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds, with saturation, the corresponding elements of two 128-bit signed [16 x i8] vectors, saving each sum in the corresponding element of a 128-bit result vector of [16 x i8].

Positive sums greater than 0x7F are saturated to 0x7F. Negative sums less than 0x80 are saturated to 0x80.

This intrinsic corresponds to the `VPADDSB / PADDSB` instruction.

Parameters

  __a | A 128-bit signed [16 x i8] vector.
  __b | A 128-bit signed [16 x i8] vector.

Returns
  A 128-bit signed [16 x i8] vector containing the saturated sums of both parameters.

Definition at line 2222 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_adds_epi8(), and _mm_maskz_adds_epi8().

## ◆ _mm_adds_epu16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_adds_epu16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds, with saturation, the corresponding elements of two 128-bit unsigned [8 x i16] vectors, saving each sum in the corresponding element of a 128-bit result vector of [8 x i16].

Positive sums greater than 0xFFFF are saturated to 0xFFFF. Negative sums are saturated to 0x0000.

This intrinsic corresponds to the `VPADDUSB / PADDUSB` instruction.

Parameters

  __a | A 128-bit unsigned [8 x i16] vector.
  __b | A 128-bit unsigned [8 x i16] vector.

Returns
  A 128-bit unsigned [8 x i16] vector containing the saturated sums of both parameters.

Definition at line 2286 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_adds_epu16(), and _mm_maskz_adds_epu16().

## ◆ _mm_adds_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_adds_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Adds, with saturation, the corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving each sum in the corresponding element of a 128-bit result vector of [16 x i8].

Positive sums greater than 0xFF are saturated to 0xFF. Negative sums are saturated to 0x00.

This intrinsic corresponds to the `VPADDUSB / PADDUSB` instruction.

Parameters

  __a | A 128-bit unsigned [16 x i8] vector.
  __b | A 128-bit unsigned [16 x i8] vector.

Returns
  A 128-bit unsigned [16 x i8] vector containing the saturated sums of both parameters.

Definition at line 2265 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_adds_epu8(), and _mm_maskz_adds_epu8().

## ◆ _mm_and_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_and_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs a bitwise AND of two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VPAND / PAND` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] containing the bitwise AND of the values between both operands.

Definition at line 350 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_and_pd(), and _mm_maskz_and_pd().

## ◆ _mm_and_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_and_si128 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Performs a bitwise AND of two 128-bit integer vectors.

This intrinsic corresponds to the `VPAND / PAND` instruction.

Parameters

  __a | A 128-bit integer vector containing one of the source operands.
  __b | A 128-bit integer vector containing one of the source operands.

Returns
  A 128-bit integer vector containing the bitwise AND of the values in both operands.

Definition at line 2743 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_test_epi16_mask(), _mm_mask_test_epi32_mask(), _mm_mask_test_epi64_mask(), _mm_mask_test_epi8_mask(), _mm_mask_testn_epi16_mask(), _mm_mask_testn_epi32_mask(), _mm_mask_testn_epi64_mask(), _mm_mask_testn_epi8_mask(), _mm_test_epi16_mask(), _mm_test_epi32_mask(), _mm_test_epi64_mask(), _mm_test_epi8_mask(), _mm_testn_epi16_mask(), _mm_testn_epi32_mask(), _mm_testn_epi64_mask(), and _mm_testn_epi8_mask().

## ◆ _mm_andnot_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_andnot_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs a bitwise AND of two 128-bit vectors of [2 x double], using the one's complement of the values contained in the first source operand.

This intrinsic corresponds to the `VPANDN / PANDN` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the left source operand. The one's complement of this value is used in the bitwise AND.
  __b | A 128-bit vector of [2 x double] containing the right source operand.

Returns
  A 128-bit vector of [2 x double] containing the bitwise AND of the values in the second operand and the one's complement of the first operand.

Definition at line 371 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_andnot_pd(), and _mm_maskz_andnot_pd().

## ◆ _mm_andnot_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_andnot_si128 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Performs a bitwise AND of two 128-bit integer vectors, using the one's complement of the values contained in the first source operand.

This intrinsic corresponds to the `VPANDN / PANDN` instruction.

Parameters

  __a | A 128-bit vector containing the left source operand. The one's complement of this value is used in the bitwise AND.
  __b | A 128-bit vector containing the right source operand.

Returns
  A 128-bit integer vector containing the bitwise AND of the one's complement of the first operand and the values in the second operand.

Definition at line 2763 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_avg_epu16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_avg_epu16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Computes the rounded averages of corresponding elements of two 128-bit unsigned [8 x i16] vectors, saving each result in the corresponding element of a 128-bit result vector of [8 x i16].

This intrinsic corresponds to the `VPAVGW / PAVGW` instruction.

Parameters

  __a | A 128-bit unsigned [8 x i16] vector.
  __b | A 128-bit unsigned [8 x i16] vector.

Returns
  A 128-bit unsigned [8 x i16] vector containing the rounded averages of both parameters.

Definition at line 2326 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_avg_epu16(), and _mm_maskz_avg_epu16().

## ◆ _mm_avg_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_avg_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Computes the rounded averages of corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving each result in the corresponding element of a 128-bit result vector of [16 x i8].

This intrinsic corresponds to the `VPAVGB / PAVGB` instruction.

Parameters

  __a | A 128-bit unsigned [16 x i8] vector.
  __b | A 128-bit unsigned [16 x i8] vector.

Returns
  A 128-bit unsigned [16 x i8] vector containing the rounded averages of both parameters.

Definition at line 2306 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_avg_epu8(), and _mm_maskz_avg_epu8().

## ◆ _mm_castpd_ps()

static __inline__ __m128 __DEFAULT_FN_ATTRS _mm_castpd_ps | ( | __m128d | __a | ) |
| static

Casts a 128-bit floating-point vector of [2 x double] into a 128-bit floating-point vector of [4 x float].

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit floating-point vector of [2 x double].

Returns
  A 128-bit floating-point vector of [4 x float] containing the same bitwise pattern as the parameter.

Definition at line 4862 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_castpd_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_castpd_si128 | ( | __m128d | __a | ) |
| static

Casts a 128-bit floating-point vector of [2 x double] into a 128-bit integer vector.

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit floating-point vector of [2 x double].

Returns
  A 128-bit integer vector containing the same bitwise pattern as the parameter.

Definition at line 4879 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_castps_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_castps_pd | ( | __m128 | __a | ) |
| static

Casts a 128-bit floating-point vector of [4 x float] into a 128-bit floating-point vector of [2 x double].

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit floating-point vector of [4 x float].

Returns
  A 128-bit floating-point vector of [2 x double] containing the same bitwise pattern as the parameter.

Definition at line 4896 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_castps_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_castps_si128 | ( | __m128 | __a | ) |
| static

Casts a 128-bit floating-point vector of [4 x float] into a 128-bit integer vector.

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit floating-point vector of [4 x float].

Returns
  A 128-bit integer vector containing the same bitwise pattern as the parameter.

Definition at line 4913 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_castsi128_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_castsi128_pd | ( | __m128i | __a | ) |
| static

Casts a 128-bit integer vector into a 128-bit floating-point vector of [2 x double].

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit integer vector.

Returns
  A 128-bit floating-point vector of [2 x double] containing the same bitwise pattern as the parameter.

Definition at line 4947 of file emmintrin.h.

References __a, and _mm_pause().

## ◆ _mm_castsi128_ps()

static __inline__ __m128 __DEFAULT_FN_ATTRS _mm_castsi128_ps | ( | __m128i | __a | ) |
| static

Casts a 128-bit integer vector into a 128-bit floating-point vector of [4 x float].

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit integer vector.

Returns
  A 128-bit floating-point vector of [4 x float] containing the same bitwise pattern as the parameter.

Definition at line 4930 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_clflush()

void _mm_clflush | ( | void const * | __p | ) |

The cache line containing __p is flushed and invalidated from all caches in the coherency domain.

This intrinsic corresponds to the `CLFLUSH` instruction.

Parameters

  __p | A pointer to the memory location used to identify the cache line to be flushed.

## ◆ _mm_cmpeq_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpeq_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding 16-bit values of the 128-bit integer vectors for equality.

Each comparison yields 0x0 for false, 0xFFFF for true.

This intrinsic corresponds to the `VPCMPEQW / PCMPEQW` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3190 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpeq_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpeq_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding 32-bit values of the 128-bit integer vectors for equality.

Each comparison yields 0x0 for false, 0xFFFFFFFF for true.

This intrinsic corresponds to the `VPCMPEQD / PCMPEQD` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3209 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpeq_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpeq_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding 8-bit values of the 128-bit integer vectors for equality.

Each comparison yields 0x0 for false, 0xFF for true.

This intrinsic corresponds to the `VPCMPEQB / PCMPEQB` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3171 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by isEndOfBlockCommentWithEscapedNewLine().

## ◆ _mm_cmpeq_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpeq_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] for equality.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPEQPD / CMPEQPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 426 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpeq_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpeq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPEQSD / CMPEQSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 684 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpge_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpge_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are greater than or equal to those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLEPD / CMPLEPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 509 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpge_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpge_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLESD / CMPLESD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 785 of file emmintrin.h.

References __c, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpgt_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpgt_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 16-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFF for true.

This intrinsic corresponds to the `VPCMPGTW / PCMPGTW` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3252 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_cmplt_epi16().

## ◆ _mm_cmpgt_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpgt_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 32-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFF for true.

This intrinsic corresponds to the `VPCMPGTD / PCMPGTD` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3273 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_cmplt_epi32().

## ◆ _mm_cmpgt_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmpgt_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 8-bit values of the 128-bit integer vectors to determine if the values in the first operand are greater than those in the second operand.

Each comparison yields 0x0 for false, 0xFF for true.

This intrinsic corresponds to the `VPCMPGTB / PCMPGTB` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3229 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_cmplt_epi8().

## ◆ _mm_cmpgt_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpgt_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are greater than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLTPD / CMPLTPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 488 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpgt_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpgt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLTSD / CMPLTSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 759 of file emmintrin.h.

References __c, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmple_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmple_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are less than or equal to those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLEPD / CMPLEPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 467 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmple_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmple_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLESD / CMPLESD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 734 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmplt_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmplt_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 16-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFF for true.

This intrinsic corresponds to the `VPCMPGTW / PCMPGTW` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3315 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_cmpgt_epi16().

## ◆ _mm_cmplt_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmplt_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 32-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFF for true.

This intrinsic corresponds to the `VPCMPGTD / PCMPGTD` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3336 of file emmintrin.h.

References __a, __b, __DEFAULT_FN_ATTRS, and _mm_cmpgt_epi32().

## ◆ _mm_cmplt_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cmplt_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares each of the corresponding signed 8-bit values of the 128-bit integer vectors to determine if the values in the first operand are less than those in the second operand.

Each comparison yields 0x0 for false, 0xFF for true.

This intrinsic corresponds to the `VPCMPGTB / PCMPGTB` instruction.

Parameters

  __a | A 128-bit integer vector.
  __b | A 128-bit integer vector.

Returns
  A 128-bit integer vector containing the comparison results.

Definition at line 3294 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_cmpgt_epi8().

## ◆ _mm_cmplt_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmplt_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are less than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLTPD / CMPLTPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 446 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmplt_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmplt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPLTSD / CMPLTSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 709 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpneq_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpneq_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are unequal to those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNEQPD / CMPNEQPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 577 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpneq_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpneq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNEQSD / CMPNEQSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 866 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnge_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnge_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not greater than or equal to those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLEPD / CMPNLEPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 661 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnge_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnge_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not greater than or equal to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLESD / CMPNLESD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 967 of file emmintrin.h.

References __c, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpngt_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpngt_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not greater than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLTPD / CMPNLTPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 640 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpngt_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpngt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not greater than the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLTSD / CMPNLTSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 941 of file emmintrin.h.

References __c, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnle_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnle_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not less than or equal to those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLEPD / CMPNLEPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 619 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnle_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnle_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not less than or equal to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLESD / CMPNLESD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 916 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnlt_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnlt_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are not less than those in the second operand.

Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLTPD / CMPNLTPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 598 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpnlt_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpnlt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is not less than the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPNLTSD / CMPNLTSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 891 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpord_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpord_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are ordered with respect to those in the second operand.

A pair of double-precision values are "ordered" with respect to each other if neither value is a NaN. Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPORDPD / CMPORDPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 532 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpord_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpord_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is "ordered" with respect to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true. A pair of double-precision values are "ordered" with respect to each other if neither value is a NaN.

This intrinsic corresponds to the `VCMPORDSD / CMPORDSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 813 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpunord_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpunord_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares each of the corresponding double-precision values of the 128-bit vectors of [2 x double] to determine if the values in the first operand are unordered with respect to those in the second operand.

A pair of double-precision values are "unordered" with respect to each other if one or both values are NaN. Each comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true.

This intrinsic corresponds to the `VCMPUNORDPD / CMPUNORDPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].
  __b | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector containing the comparison results.

Definition at line 556 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cmpunord_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cmpunord_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is "unordered" with respect to the corresponding value in the second parameter.

The comparison yields 0x0 for false, 0xFFFFFFFFFFFFFFFF for true. A pair of double-precision values are "unordered" with respect to each other if one or both values are NaN.

This intrinsic corresponds to the `VCMPUNORDSD / CMPUNORDSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  A 128-bit vector. The lower 64 bits contains the comparison results. The upper 64 bits are copied from the upper 64 bits of __a.

Definition at line 841 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comieq_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comieq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 992 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comige_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comige_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1096 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comigt_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comigt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1070 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comile_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comile_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1044 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comilt_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comilt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1018 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_comineq_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_comineq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 1 is returned.

This intrinsic corresponds to the `VCOMISD / COMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 1 is returned.

Definition at line 1122 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtepi32_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cvtepi32_pd | ( | __m128i | __a | ) |
| static

Converts the lower two integer elements of a 128-bit vector of [4 x i32] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double].

The upper two elements of the input vector are unused.

This intrinsic corresponds to the `VCVTDQ2PD / CVTDQ2PD` instruction.

Parameters

  __a | A 128-bit integer vector of [4 x i32]. The lower two integer elements are converted to double-precision values.

The upper two elements are unused.

Returns
  A 128-bit vector of [2 x double] containing the converted values.

Definition at line 1338 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_cvtepi32_pd(), and _mm_maskz_cvtepi32_pd().

## ◆ _mm_cvtepi32_ps()

static __inline__ __m128 __DEFAULT_FN_ATTRS _mm_cvtepi32_ps | ( | __m128i | __a | ) |
| static

Converts a vector of [4 x i32] into a vector of [4 x float].

This intrinsic corresponds to the `VCVTDQ2PS / CVTDQ2PS` instruction.

Parameters

  __a | A 128-bit integer vector.

Returns
  A 128-bit vector of [4 x float] containing the converted values.

Definition at line 3412 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_cvtepi32_ps(), and _mm_maskz_cvtepi32_ps().

## ◆ _mm_cvtpd_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cvtpd_epi32 | ( | __m128d | __a | ) |
| static

Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in the lower 64 bits of a 128-bit vector of [4 x i32].

The upper 64 bits of the result vector are set to zero.

This intrinsic corresponds to the `VCVTPD2DQ / CVTPD2DQ` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector of [4 x i32] whose lower 64 bits contain the converted values. The upper 64 bits are set to zero.

Definition at line 1358 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtpd_pi32()

static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX _mm_cvtpd_pi32 | ( | __m128d | __a | ) |
| static

Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in a 64-bit vector of [2 x i32].

This intrinsic corresponds to the `CVTPD2PI` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 64-bit vector of [2 x i32] containing the converted values.

Definition at line 1508 of file emmintrin.h.

References __DEFAULT_FN_ATTRS_MMX.

## ◆ _mm_cvtpd_ps()

static __inline__ __m128 __DEFAULT_FN_ATTRS _mm_cvtpd_ps | ( | __m128d | __a | ) |
| static

Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two single-precision floating-point values, returned in the lower 64 bits of a 128-bit vector of [4 x float].

The upper 64 bits of the result vector are set to zero.

This intrinsic corresponds to the `VCVTPD2PS / CVTPD2PS` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector of [4 x float] whose lower 64 bits contain the converted values. The upper 64 bits are set to zero.

Definition at line 1295 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtpi32_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS_MMX _mm_cvtpi32_pd | ( | __m64 | __a | ) |
| static

Converts the two signed 32-bit integer elements of a 64-bit vector of [2 x i32] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double].

This intrinsic corresponds to the `CVTPI2PD` instruction.

Parameters

  __a | A 64-bit vector of [2 x i32].

Returns
  A 128-bit vector of [2 x double] containing the converted values.

Definition at line 1545 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtps_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cvtps_epi32 | ( | __m128 | __a | ) |
| static

Converts a vector of [4 x float] into a vector of [4 x i32].

This intrinsic corresponds to the `VCVTPS2DQ / CVTPS2DQ` instruction.

Parameters

  __a | A 128-bit vector of [4 x float].

Returns
  A 128-bit integer vector of [4 x i32] containing the converted values.

Definition at line 3428 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_cvtps_epi32(), and _mm_maskz_cvtps_epi32().

## ◆ _mm_cvtps_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cvtps_pd | ( | __m128 | __a | ) |
| static

Converts the lower two single-precision floating-point elements of a 128-bit vector of [4 x float] into two double-precision floating-point values, returned in a 128-bit vector of [2 x double].

The upper two elements of the input vector are unused.

This intrinsic corresponds to the `VCVTPS2PD / CVTPS2PD` instruction.

Parameters

  __a | A 128-bit vector of [4 x float]. The lower two single-precision floating-point elements are converted to double-precision values. The upper two elements are unused.

Returns
  A 128-bit vector of [2 x double] containing the converted values.

Definition at line 1315 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_cvtps_pd(), and _mm_maskz_cvtps_pd().

## ◆ _mm_cvtsd_f64()

static __inline__ double __DEFAULT_FN_ATTRS _mm_cvtsd_f64 | ( | __m128d | __a | ) |
| static

Returns the low-order element of a 128-bit vector of [2 x double] as a double-precision floating-point value.

This intrinsic has no corresponding instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower 64 bits are returned.

Returns
  A double-precision floating-point value copied from the lower 64 bits of __a.

Definition at line 1562 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtsd_si32()

static __inline__ int __DEFAULT_FN_ATTRS _mm_cvtsd_si32 | ( | __m128d | __a | ) |
| static

Converts the low-order element of a 128-bit vector of [2 x double] into a 32-bit signed integer value.

This intrinsic corresponds to the `VCVTSD2SI / CVTSD2SI` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower 64 bits are used in the conversion.

Returns
  A 32-bit signed integer containing the converted value.

Definition at line 1375 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtsd_ss()

static __inline__ __m128 __DEFAULT_FN_ATTRS _mm_cvtsd_ss | ( | __m128 | __a,
|  | __m128d | __b
| ) |  |
| static

Converts the lower double-precision floating-point element of a 128-bit vector of [2 x double], in the second parameter, into a single-precision floating-point value, returned in the lower 32 bits of a 128-bit vector of [4 x float].

The upper 96 bits of the result vector are copied from the upper 96 bits of the first parameter.

This intrinsic corresponds to the `VCVTSD2SS / CVTSD2SS` instruction.

Parameters

  __a | A 128-bit vector of [4 x float]. The upper 96 bits of this parameter are copied to the upper 96 bits of the result.
  __b | A 128-bit vector of [2 x double]. The lower double-precision floating-point element is used in the conversion.

Returns
  A 128-bit vector of [4 x float]. The lower 32 bits contain the converted value from the second parameter. The upper 96 bits are copied from the upper 96 bits of the first parameter.

Definition at line 1400 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtsi128_si32()

static __inline__ int __DEFAULT_FN_ATTRS _mm_cvtsi128_si32 | ( | __m128i | __a | ) |
| static

Moves the least significant 32 bits of a vector of [4 x i32] to a 32-bit signed integer value.

This intrinsic corresponds to the `VMOVD / MOVD` instruction.

Parameters

  __a | A vector of [4 x i32]. The least significant 32 bits are moved to the destination.

Returns
  A 32-bit signed integer containing the moved value.

Definition at line 3496 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtsi32_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cvtsi32_sd | ( | __m128d | __a,
|  | int | __b
| ) |  |
| static

Converts a 32-bit signed integer value, in the second parameter, into a double-precision floating-point value, returned in the lower 64 bits of a 128-bit vector of [2 x double].

The upper 64 bits of the result vector are copied from the upper 64 bits of the first parameter.

This intrinsic corresponds to the `VCVTSI2SD / CVTSI2SD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The upper 64 bits of this parameter are copied to the upper 64 bits of the result.
  __b | A 32-bit signed integer containing the value to be converted.

Returns
  A 128-bit vector of [2 x double]. The lower 64 bits contain the converted value from the second parameter. The upper 64 bits are copied from the upper 64 bits of the first parameter.

Definition at line 1423 of file emmintrin.h.

References __a, __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtsi32_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cvtsi32_si128 | ( | int | __a | ) |
| static

Returns a vector of [4 x i32] where the lowest element is the input operand and the remaining elements are zero.

This intrinsic corresponds to the `VMOVD / MOVD` instruction.

Parameters

  __a | A 32-bit signed integer operand.

Returns
  A 128-bit vector of [4 x i32].

Definition at line 3461 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cvtss_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_cvtss_sd | ( | __m128d | __a,
|  | __m128 | __b
| ) |  |
| static

Converts the lower single-precision floating-point element of a 128-bit vector of [4 x float], in the second parameter, into a double-precision floating-point value, returned in the lower 64 bits of a 128-bit vector of [2 x double].

The upper 64 bits of the result vector are copied from the upper 64 bits of the first parameter.

This intrinsic corresponds to the `VCVTSS2SD / CVTSS2SD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The upper 64 bits of this parameter are copied to the upper 64 bits of the result.
  __b | A 128-bit vector of [4 x float]. The lower single-precision floating-point element is used in the conversion.

Returns
  A 128-bit vector of [2 x double]. The lower 64 bits contain the converted value from the second parameter. The upper 64 bits are copied from the upper 64 bits of the first parameter.

Definition at line 1449 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

## ◆ _mm_cvttpd_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cvttpd_epi32 | ( | __m128d | __a | ) |
| static

Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in the lower 64 bits of a 128-bit vector of [4 x i32].

If the result of either conversion is inexact, the result is truncated (rounded towards zero) regardless of the current MXCSR setting. The upper 64 bits of the result vector are set to zero.

This intrinsic corresponds to the `VCVTTPD2DQ / CVTTPD2DQ` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector of [4 x i32] whose lower 64 bits contain the converted values. The upper 64 bits are set to zero.

Definition at line 1473 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_cvttpd_pi32()

static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX _mm_cvttpd_pi32 | ( | __m128d | __a | ) |
| static

Converts the two double-precision floating-point elements of a 128-bit vector of [2 x double] into two signed 32-bit integer values, returned in a 64-bit vector of [2 x i32].

If the result of either conversion is inexact, the result is truncated (rounded towards zero) regardless of the current MXCSR setting.

This intrinsic corresponds to the `CVTTPD2PI` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 64-bit vector of [2 x i32] containing the converted values.

Definition at line 1528 of file emmintrin.h.

References __DEFAULT_FN_ATTRS_MMX.

## ◆ _mm_cvttps_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_cvttps_epi32 | ( | __m128 | __a | ) |
| static

Converts a vector of [4 x float] into a vector of [4 x i32], truncating the result when it is inexact.

This intrinsic corresponds to the `VCVTTPS2DQ / CVTTPS2DQ` instruction.

Parameters

  __a | A 128-bit vector of [4 x float].

Returns
  A 128-bit vector of [4 x i32] containing the converted values.

Definition at line 3445 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_cvttps_epi32(), and _mm_maskz_cvttps_epi32().

## ◆ _mm_cvttsd_si32()

static __inline__ int __DEFAULT_FN_ATTRS _mm_cvttsd_si32 | ( | __m128d | __a | ) |
| static

Converts the low-order element of a [2 x double] vector into a 32-bit signed integer value, truncating the result when it is inexact.

This intrinsic corresponds to the `VCVTTSD2SI / CVTTSD2SI` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower 64 bits are used in the conversion.

Returns
  A 32-bit signed integer containing the converted value.

Definition at line 1491 of file emmintrin.h.

References __DEFAULT_FN_ATTRS_MMX.

## ◆ _mm_div_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_div_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs an element-by-element division of two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VDIVPD / DIVPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the dividend.
  __b | A 128-bit vector of [2 x double] containing the divisor.

Returns
  A 128-bit vector of [2 x double] containing the quotients of both operands.

Definition at line 201 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_div_pd(), and _mm_maskz_div_pd().

## ◆ _mm_div_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_div_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Divides the lower double-precision value of the first operand by the lower double-precision value of the second operand and returns the quotient in the lower 64 bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VDIVSD / DIVSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the dividend.
  __b | A 128-bit vector of [2 x double] containing divisor.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the quotient of the lower 64 bits of both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 181 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_div_sd(), and _mm_maskz_div_sd().

## ◆ _mm_lfence()

void _mm_lfence | ( | void |  | ) |

Forces strong memory ordering (serialization) between load instructions preceding this instruction and load instructions following this instruction, ensuring the system completes all previous loads before executing subsequent loads.

This intrinsic corresponds to the `LFENCE` instruction.

## ◆ _mm_load1_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_load1_pd | ( | double const * | __dp | ) |
| static

Loads a double-precision floating-point value from a specified memory location and duplicates it to both vector elements of a 128-bit vector of [2 x double].

This intrinsic corresponds to the `VMOVDDUP / MOVDDUP` instruction.

Parameters

  __dp | A pointer to a memory location containing a double-precision value.

Returns
  A 128-bit vector of [2 x double] containing the loaded and duplicated values.

Definition at line 1597 of file emmintrin.h.

## ◆ _mm_load_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_load_pd | ( | double const * | __dp | ) |
| static

Loads a 128-bit floating-point vector of [2 x double] from an aligned memory location.

This intrinsic corresponds to the `VMOVAPD / MOVAPD` instruction.

Parameters

  __dp | A pointer to a 128-bit memory location. The address of the memory location has to be 16-byte aligned.

Returns
  A 128-bit vector of [2 x double] containing the loaded values.

Definition at line 1579 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_load_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_load_sd | ( | double const * | __dp | ) |
| static

Loads a 64-bit double-precision value to the low element of a 128-bit integer vector and clears the upper element.

This intrinsic corresponds to the `VMOVSD / MOVSD` instruction.

Parameters

  __dp | A pointer to a memory location containing a double-precision value. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [2 x double] containing the loaded value.

Definition at line 1724 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_load_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_load_si128 | ( | __m128i const * | __p | ) |
| static

Moves packed integer values from an aligned 128-bit memory location to elements in a 128-bit integer vector.

This intrinsic corresponds to the `VMOVDQA / MOVDQA` instruction.

Parameters

  __p | An aligned pointer to a memory location containing integer values.

Returns
  A 128-bit integer vector containing the moved values.

Definition at line 3532 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __p.

## ◆ _mm_loadh_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_loadh_pd | ( | __m128d | __a,
|  | double const * | __dp
| ) |  |
| static

Loads a double-precision value into the high-order bits of a 128-bit vector of [2 x double].

The low-order bits are copied from the low-order bits of the first operand.

This intrinsic corresponds to the `VMOVHPD / MOVHPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. Bits [63:0] are written to bits [63:0] of the result.
  __dp | A pointer to a 64-bit memory location containing a double-precision floating-point value that is loaded. The loaded value is written to bits [127:64] of the result. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [2 x double] containing the moved values.

Definition at line 1751 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_loadl_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_loadl_epi64 | ( | __m128i_u const * | __p | ) |
| static

Returns a vector of [2 x i64] where the lower element is taken from the lower element of the operand, and the upper element is zero.

This intrinsic corresponds to the `VMOVQ / MOVQ` instruction.

Parameters

  __p | A 128-bit vector of [2 x i64]. Bits [63:0] are written to bits [63:0] of the destination.

Returns
  A 128-bit vector of [2 x i64]. The lower order bits contain the moved value. The higher order bits are cleared.

Definition at line 3569 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_loadl_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_loadl_pd | ( | __m128d | __a,
|  | double const * | __dp
| ) |  |
| static

Loads a double-precision value into the low-order bits of a 128-bit vector of [2 x double].

The high-order bits are copied from the high-order bits of the first operand.

This intrinsic corresponds to the `VMOVLPD / MOVLPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. Bits [127:64] are written to bits [127:64] of the result.
  __dp | A pointer to a 64-bit memory location containing a double-precision floating-point value that is loaded. The loaded value is written to bits [63:0] of the result. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [2 x double] containing the moved values.

Definition at line 1778 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_loadr_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_loadr_pd | ( | double const * | __dp | ) |
| static

Loads two double-precision values, in reverse order, from an aligned memory location into a 128-bit vector of [2 x double].

This intrinsic corresponds to the `VMOVAPD / MOVAPD` instruction + needed shuffling instructions. In AVX mode, the shuffling may be combined with the `VMOVAPD`, resulting in only a `VPERMILPD` instruction.

Parameters

  __dp | A 16-byte aligned pointer to an array of double-precision values to be loaded in reverse order.

Returns
  A 128-bit vector of [2 x double] containing the reversed loaded values.

Definition at line 1623 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_loadu_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_loadu_pd | ( | double const * | __dp | ) |
| static

Loads a 128-bit floating-point vector of [2 x double] from an unaligned memory location.

This intrinsic corresponds to the `VMOVUPD / MOVUPD` instruction.

Parameters

  __dp | A pointer to a 128-bit memory location. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [2 x double] containing the loaded values.

Definition at line 1641 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

Referenced by _mm256_broadcast_pd(), and _mm256_loadu2_m128d().

## ◆ _mm_loadu_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_loadu_si128 | ( | __m128i_u const * | __p | ) |
| static

Moves packed integer values from an unaligned 128-bit memory location to elements in a 128-bit integer vector.

This intrinsic corresponds to the `VMOVDQU / MOVDQU` instruction.

Parameters

  __p | A pointer to a memory location containing integer values.

Returns
  A 128-bit integer vector containing the moved values.

Definition at line 3548 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

Referenced by _mm256_loadu2_m128i().

## ◆ _mm_loadu_si16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_loadu_si16 | ( | void const * | __a | ) |
| static

Loads a 16-bit integer value to the low element of a 128-bit integer vector and clears the upper element.

This intrinsic does not correspond to a specific instruction.

Parameters

  __a | A pointer to a 16-bit memory location. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [8 x i16] containing the loaded value.

Definition at line 1703 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_loadu_si32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_loadu_si32 | ( | void const * | __a | ) |
| static

Loads a 32-bit integer value to the low element of a 128-bit integer vector and clears the upper element.

This intrinsic corresponds to the `VMOVD / MOVD` instruction.

Parameters

  __a | A pointer to a 32-bit memory location. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [4 x i32] containing the loaded value.

Definition at line 1682 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_loadu_si64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_loadu_si64 | ( | void const * | __a | ) |
| static

Loads a 64-bit integer value to the low element of a 128-bit integer vector and clears the upper element.

This intrinsic corresponds to the `VMOVQ / MOVQ` instruction.

Parameters

  __a | A pointer to a 64-bit memory location. The address of the memory location does not have to be aligned.

Returns
  A 128-bit vector of [2 x i64] containing the loaded value.

Definition at line 1661 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_madd_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_madd_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Multiplies the corresponding elements of two 128-bit signed [8 x i16] vectors, producing eight intermediate 32-bit signed integer products, and adds the consecutive pairs of 32-bit products to form a 128-bit signed [4 x i32] vector.

For example, bits [15:0] of both parameters are multiplied producing a 32-bit product, bits [31:16] of both parameters are multiplied producing a 32-bit product, and the sum of those two products becomes bits [31:0] of the result.

This intrinsic corresponds to the `VPMADDWD / PMADDWD` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [4 x i32] vector containing the sums of products of both parameters.

Definition at line 2352 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_madd_epi16(), and _mm_maskz_madd_epi16().

## ◆ _mm_maskmoveu_si128()

static __inline__ void __DEFAULT_FN_ATTRS _mm_maskmoveu_si128 | ( | __m128i | __d,
|  | __m128i | __n,
|  | char * | __p
| ) |  |
| static

Moves bytes selected by the mask from the first operand to the specified unaligned memory location.

When a mask bit is 1, the corresponding byte is written, otherwise it is not written.

To minimize caching, the data is flagged as non-temporal (unlikely to be used again soon). Exception and trap behavior for elements not selected for storage to memory are implementation dependent.

This intrinsic corresponds to the `VMASKMOVDQU / MASKMOVDQU` instruction.

Parameters

  __d | A 128-bit integer vector containing the values to be moved.
  __n | A 128-bit integer vector containing the mask. The most significant bit of each byte represents the mask bits.
  __p | A pointer to an unaligned 128-bit memory location where the specified values are moved.

Definition at line 4104 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_max_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_max_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares corresponding elements of two 128-bit signed [8 x i16] vectors, saving the greater value from each comparison in the corresponding element of a 128-bit result vector of [8 x i16].

This intrinsic corresponds to the `VPMAXSW / PMAXSW` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [8 x i16] vector containing the greater value of each comparison.

Definition at line 2372 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_max_epi16(), and _mm_maskz_max_epi16().

## ◆ _mm_max_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_max_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving the greater value from each comparison in the corresponding element of a 128-bit result vector of [16 x i8].

This intrinsic corresponds to the `VPMAXUB / PMAXUB` instruction.

Parameters

  __a | A 128-bit unsigned [16 x i8] vector.
  __b | A 128-bit unsigned [16 x i8] vector.

Returns
  A 128-bit unsigned [16 x i8] vector containing the greater value of each comparison.

Definition at line 2392 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_max_epu8(), and _mm_maskz_max_epu8().

## ◆ _mm_max_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_max_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs element-by-element comparison of the two 128-bit vectors of [2 x double] and returns the vector containing the greater of each pair of values.

This intrinsic corresponds to the `VMAXPD / MAXPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands.
  __b | A 128-bit vector of [2 x double] containing one of the operands.

Returns
  A 128-bit vector of [2 x double] containing the maximum values between both operands.

Definition at line 332 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_max_pd(), and _mm_maskz_max_pd().

## ◆ _mm_max_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_max_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares lower 64-bit double-precision values of both operands, and returns the greater of the pair of values in the lower 64-bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VMAXSD / MAXSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands. The lower 64 bits of this operand are used in the comparison.
  __b | A 128-bit vector of [2 x double] containing one of the operands. The lower 64 bits of this operand are used in the comparison.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the maximum value between both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 312 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_mfence()

void _mm_mfence | ( | void |  | ) |

Forces strong memory ordering (serialization) between load and store instructions preceding this instruction and load and store instructions following this instruction, ensuring that the system completes all previous memory accesses before executing subsequent memory accesses.

This intrinsic corresponds to the `MFENCE` instruction.

## ◆ _mm_min_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_min_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares corresponding elements of two 128-bit signed [8 x i16] vectors, saving the smaller value from each comparison in the corresponding element of a 128-bit result vector of [8 x i16].

This intrinsic corresponds to the `VPMINSW / PMINSW` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [8 x i16] vector containing the smaller value of each comparison.

Definition at line 2412 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_min_epi16(), and _mm_maskz_min_epi16().

## ◆ _mm_min_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_min_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Compares corresponding elements of two 128-bit unsigned [16 x i8] vectors, saving the smaller value from each comparison in the corresponding element of a 128-bit result vector of [16 x i8].

This intrinsic corresponds to the `VPMINUB / PMINUB` instruction.

Parameters

  __a | A 128-bit unsigned [16 x i8] vector.
  __b | A 128-bit unsigned [16 x i8] vector.

Returns
  A 128-bit unsigned [16 x i8] vector containing the smaller value of each comparison.

Definition at line 2432 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_min_epu8(), and _mm_maskz_min_epu8().

## ◆ _mm_min_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_min_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs element-by-element comparison of the two 128-bit vectors of [2 x double] and returns the vector containing the lesser of each pair of values.

This intrinsic corresponds to the `VMINPD / MINPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands.
  __b | A 128-bit vector of [2 x double] containing one of the operands.

Returns
  A 128-bit vector of [2 x double] containing the minimum values between both operands.

Definition at line 288 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_min_pd(), and _mm_maskz_min_pd().

## ◆ _mm_min_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_min_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares lower 64-bit double-precision values of both operands, and returns the lesser of the pair of values in the lower 64-bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VMINSD / MINSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands. The lower 64 bits of this operand are used in the comparison.
  __b | A 128-bit vector of [2 x double] containing one of the operands. The lower 64 bits of this operand are used in the comparison.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the minimum value between both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 268 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_move_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_move_epi64 | ( | __m128i | __a | ) |
| static

Moves the lower 64 bits of a 128-bit integer vector to a 128-bit integer vector, zeroing the upper bits.

This intrinsic corresponds to the `VMOVQ / MOVQ` instruction.

Parameters

  __a | A 128-bit integer vector operand. The lower 64 bits are moved to the destination.

Returns
  A 128-bit integer vector. The lower 64 bits contain the value from the operand. The upper 64 bits are assigned zeros.

Definition at line 4755 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_setzero_si128().

## ◆ _mm_move_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_move_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Constructs a 128-bit floating-point vector of [2 x double].

The lower 64 bits are set to the lower 64 bits of the second parameter. The upper 64 bits are set to the upper 64 bits of the first parameter.

This intrinsic corresponds to the `VBLENDPD / BLENDPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The upper 64 bits are written to the upper 64 bits of the result.
  __b | A 128-bit vector of [2 x double]. The lower 64 bits are written to the lower 64 bits of the result.

Returns
  A 128-bit vector of [2 x double] containing the moved values.

Definition at line 1932 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_move_sd(), and _mm_maskz_move_sd().

## ◆ _mm_movemask_epi8()

static __inline__ int __DEFAULT_FN_ATTRS _mm_movemask_epi8 | ( | __m128i | __a | ) |
| static

Copies the values of the most significant bits from each 8-bit element in a 128-bit integer vector of [16 x i8] to create a 16-bit mask value, zero-extends the value, and writes it to the destination.

This intrinsic corresponds to the `VPMOVMSKB / PMOVMSKB` instruction.

Parameters

  __a | A 128-bit integer vector containing the values with bits to be extracted.

Returns
  The most significant bits from each 8-bit element in __a, written to bits [15:0]. The other bits are assigned zeros.

Definition at line 4399 of file emmintrin.h.

Referenced by isEndOfBlockCommentWithEscapedNewLine().

## ◆ _mm_movemask_pd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_movemask_pd | ( | __m128d | __a | ) |
| static

Extracts the sign bits of the double-precision values in the 128-bit vector of [2 x double], zero-extends the value, and writes it to the low-order bits of the destination.

This intrinsic corresponds to the `VMOVMSKPD / MOVMSKPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the values with sign bits to be extracted.

Returns
  The sign bits from each of the double-precision elements in __a, written to bits [1:0]. The remaining bits are assigned values of zero.

Definition at line 4816 of file emmintrin.h.

## ◆ _mm_movepi64_pi64()

static __inline__ __m64 __DEFAULT_FN_ATTRS _mm_movepi64_pi64 | ( | __m128i | __a | ) |
| static

Returns the lower 64 bits of a 128-bit integer vector as a 64-bit integer.

This intrinsic corresponds to the `MOVDQ2Q` instruction.

Parameters

  __a | A 128-bit integer vector operand. The lower 64 bits are moved to the destination.

Returns
  A 64-bit integer containing the lower 64 bits of the parameter.

Definition at line 4720 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_movpi64_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_movpi64_epi64 | ( | __m64 | __a | ) |
| static

Moves the 64-bit operand to a 128-bit integer vector, zeroing the upper bits.

This intrinsic corresponds to the `MOVD+VMOVQ` instruction.

Parameters

  __a | A 64-bit value.

Returns
  A 128-bit integer vector. The lower 64 bits contain the value from the operand. The upper 64 bits are assigned zeros.

Definition at line 4737 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_mul_epu32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_mul_epu32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Multiplies 32-bit unsigned integer values contained in the lower bits of the corresponding elements of two [2 x i64] vectors, and returns the 64-bit products in the corresponding elements of a [2 x i64] vector.

This intrinsic corresponds to the `VPMULUDQ / PMULUDQ` instruction.

Parameters

  __a | A [2 x i64] vector containing one of the source operands.
  __b | A [2 x i64] vector containing one of the source operands.

Returns
  A [2 x i64] vector containing the product of both operands.

Definition at line 2530 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_mul_epu32(), and _mm_maskz_mul_epu32().

## ◆ _mm_mul_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_mul_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Multiplies two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VMULPD / MULPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands.
  __b | A 128-bit vector of [2 x double] containing one of the operands.

Returns
  A 128-bit vector of [2 x double] containing the products of both operands.

Definition at line 158 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_mul_pd(), and _mm_maskz_mul_pd().

## ◆ _mm_mul_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_mul_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Multiplies lower double-precision values in both operands and returns the product in the lower 64 bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VMULSD / MULSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the product of the lower 64 bits of both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 139 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_mul_sd(), and _mm_maskz_mul_sd().

## ◆ _mm_mul_su32()

static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX _mm_mul_su32 | ( | __m64 | __a,
|  | __m64 | __b
| ) |  |
| static

Multiplies 32-bit unsigned integer values contained in the lower bits of the two 64-bit integer vectors and returns the 64-bit unsigned product.

This intrinsic corresponds to the `PMULUDQ` instruction.

Parameters

  __a | A 64-bit integer containing one of the source operands.
  __b | A 64-bit integer containing one of the source operands.

Returns
  A 64-bit integer vector containing the product of both operands.

Definition at line 2511 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_mulhi_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_mulhi_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Multiplies the corresponding elements of two signed [8 x i16] vectors, saving the upper 16 bits of each 32-bit product in the corresponding element of a 128-bit signed [8 x i16] result vector.

This intrinsic corresponds to the `VPMULHW / PMULHW` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [8 x i16] vector containing the upper 16 bits of each of the eight 32-bit products.

Definition at line 2452 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_mulhi_epi16(), and _mm_maskz_mulhi_epi16().

## ◆ _mm_mulhi_epu16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_mulhi_epu16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Multiplies the corresponding elements of two unsigned [8 x i16] vectors, saving the upper 16 bits of each 32-bit product in the corresponding element of a 128-bit unsigned [8 x i16] result vector.

This intrinsic corresponds to the `VPMULHUW / PMULHUW` instruction.

Parameters

  __a | A 128-bit unsigned [8 x i16] vector.
  __b | A 128-bit unsigned [8 x i16] vector.

Returns
  A 128-bit unsigned [8 x i16] vector containing the upper 16 bits of each of the eight 32-bit products.

Definition at line 2472 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_mulhi_epu16(), and _mm_maskz_mulhi_epu16().

## ◆ _mm_mullo_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_mullo_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Multiplies the corresponding elements of two signed [8 x i16] vectors, saving the lower 16 bits of each 32-bit product in the corresponding element of a 128-bit signed [8 x i16] result vector.

This intrinsic corresponds to the `VPMULLW / PMULLW` instruction.

Parameters

  __a | A 128-bit signed [8 x i16] vector.
  __b | A 128-bit signed [8 x i16] vector.

Returns
  A 128-bit signed [8 x i16] vector containing the lower 16 bits of each of the eight 32-bit products.

Definition at line 2492 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS_MMX.

Referenced by _mm_mask_mullo_epi16(), and _mm_maskz_mullo_epi16().

## ◆ _mm_or_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_or_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs a bitwise OR of two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VPOR / POR` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] containing the bitwise OR of the values between both operands.

Definition at line 389 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_or_pd(), and _mm_maskz_or_pd().

## ◆ _mm_or_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_or_si128 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Performs a bitwise OR of two 128-bit integer vectors.

This intrinsic corresponds to the `VPOR / POR` instruction.

Parameters

  __a | A 128-bit integer vector containing one of the source operands.
  __b | A 128-bit integer vector containing one of the source operands.

Returns
  A 128-bit integer vector containing the bitwise OR of the values in both operands.

Definition at line 2780 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_packs_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_packs_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Converts 16-bit signed integers from both 128-bit integer vector operands into 8-bit signed integers, and packs the results into the destination.

Positive values greater than 0x7F are saturated to 0x7F. Negative values less than 0x80 are saturated to 0x80.

This intrinsic corresponds to the `VPACKSSWB / PACKSSWB` instruction.

Parameters

  __a | A 128-bit integer vector of [8 x i16]. Each 16-bit element is treated as a signed integer and is converted to a 8-bit signed integer with saturation. Values greater than 0x7F are saturated to 0x7F. Values less than 0x80 are saturated to 0x80. The converted [8 x i8] values are written to the lower 64 bits of the result.
  __b | A 128-bit integer vector of [8 x i16]. Each 16-bit element is treated as a signed integer and is converted to a 8-bit signed integer with saturation. Values greater than 0x7F are saturated to 0x7F. Values less than 0x80 are saturated to 0x80. The converted [8 x i8] values are written to the higher 64 bits of the result.

Returns
  A 128-bit vector of [16 x i8] containing the converted values.

Definition at line 4275 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_packs_epi16(), and _mm_maskz_packs_epi16().

## ◆ _mm_packs_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_packs_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Converts 32-bit signed integers from both 128-bit integer vector operands into 16-bit signed integers, and packs the results into the destination.

Positive values greater than 0x7FFF are saturated to 0x7FFF. Negative values less than 0x8000 are saturated to 0x8000.

This intrinsic corresponds to the `VPACKSSDW / PACKSSDW` instruction.

Parameters

  __a | A 128-bit integer vector of [4 x i32]. Each 32-bit element is treated as a signed integer and is converted to a 16-bit signed integer with saturation. Values greater than 0x7FFF are saturated to 0x7FFF. Values less than 0x8000 are saturated to 0x8000. The converted [4 x i16] values are written to the lower 64 bits of the result.
  __b | A 128-bit integer vector of [4 x i32]. Each 32-bit element is treated as a signed integer and is converted to a 16-bit signed integer with saturation. Values greater than 0x7FFF are saturated to 0x7FFF. Values less than 0x8000 are saturated to 0x8000. The converted [4 x i16] values are written to the higher 64 bits of the result.

Returns
  A 128-bit vector of [8 x i16] containing the converted values.

Definition at line 4303 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_packs_epi32(), and _mm_maskz_packs_epi32().

## ◆ _mm_packus_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_packus_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Converts 16-bit signed integers from both 128-bit integer vector operands into 8-bit unsigned integers, and packs the results into the destination.

Values greater than 0xFF are saturated to 0xFF. Values less than 0x00 are saturated to 0x00.

This intrinsic corresponds to the `VPACKUSWB / PACKUSWB` instruction.

Parameters

  __a | A 128-bit integer vector of [8 x i16]. Each 16-bit element is treated as a signed integer and is converted to an 8-bit unsigned integer with saturation. Values greater than 0xFF are saturated to 0xFF. Values less than 0x00 are saturated to 0x00. The converted [8 x i8] values are written to the lower 64 bits of the result.
  __b | A 128-bit integer vector of [8 x i16]. Each 16-bit element is treated as a signed integer and is converted to an 8-bit unsigned integer with saturation. Values greater than 0xFF are saturated to 0xFF. Values less than 0x00 are saturated to 0x00. The converted [8 x i8] values are written to the higher 64 bits of the result.

Returns
  A 128-bit vector of [16 x i8] containing the converted values.

Definition at line 4331 of file emmintrin.h.

Referenced by _mm_mask_packus_epi16(), and _mm_maskz_packus_epi16().

## ◆ _mm_pause()

void _mm_pause | ( | void |  | ) |

Indicates that a spin loop is being executed for the purposes of optimizing power consumption during the loop.

This intrinsic corresponds to the `PAUSE` instruction.

Referenced by _mm_castsi128_pd().

## ◆ _mm_sad_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sad_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Computes the absolute differences of corresponding 8-bit integer values in two 128-bit vectors.

Sums the first 8 absolute differences, and separately sums the second 8 absolute differences. Packs these two unsigned 16-bit integer sums into the upper and lower elements of a [2 x i64] vector.

This intrinsic corresponds to the `VPSADBW / PSADBW` instruction.

Parameters

  __a | A 128-bit integer vector containing one of the source operands.
  __b | A 128-bit integer vector containing one of the source operands.

Returns
  A [2 x i64] vector containing the sums of the sets of absolute differences between both operands.

Definition at line 2552 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_set1_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set1_epi16 | ( | short | __w | ) |
| static

Initializes all values in a 128-bit vector of [8 x i16] with the specified 16-bit value.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __w | A 16-bit value used to initialize the elements of the destination integer vector.

Returns
  An initialized 128-bit vector of [8 x i16] with all elements containing the value provided in the operand.

Definition at line 3823 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi16().

Referenced by _mm_mask_set1_epi16(), and _mm_maskz_set1_epi16().

## ◆ _mm_set1_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set1_epi32 | ( | int | __i | ) |
| static

Initializes all values in a 128-bit vector of [4 x i32] with the specified 32-bit value.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __i | A 32-bit value used to initialize the elements of the destination integer vector.

Returns
  An initialized 128-bit vector of [4 x i32] with all elements containing the value provided in the operand.

Definition at line 3804 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi32().

Referenced by _mm_broadcastmw_epi32(), _mm_mask_set1_epi32(), and _mm_maskz_set1_epi32().

## ◆ _mm_set1_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set1_epi64 | ( | __m64 | __q | ) |
| static

Initializes both values in a 128-bit vector of [2 x i64] with the specified 64-bit value.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __q | A 64-bit value used to initialize the elements of the destination integer vector.

Returns
  An initialized 128-bit vector of [2 x i64] with all elements containing the value provided in the operand.

Definition at line 3785 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi64().

## ◆ _mm_set1_epi64x()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set1_epi64x | ( | long long | __q | ) |
| static

Initializes both values in a 128-bit integer vector with the specified 64-bit integer value.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __q | Integer value used to initialize the elements of the destination integer vector.

Returns
  An initialized 128-bit integer vector of [2 x i64] with both elements containing the value provided in the operand.

Definition at line 3766 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi64x().

Referenced by _mm_broadcastmb_epi64(), _mm_mask_set1_epi64(), and _mm_maskz_set1_epi64().

## ◆ _mm_set1_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set1_epi8 | ( | char | __b | ) |
| static

Initializes all values in a 128-bit vector of [16 x i8] with the specified 8-bit value.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __b | An 8-bit value used to initialize the elements of the destination integer vector.

Returns
  An initialized 128-bit vector of [16 x i8] with all elements containing the value provided in the operand.

Definition at line 3842 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi8().

Referenced by _mm_mask_set1_epi8(), _mm_maskz_set1_epi8(), and isEndOfBlockCommentWithEscapedNewLine().

## ◆ _mm_set1_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_set1_pd | ( | double | __w | ) |
| static

Constructs a 128-bit floating-point vector of [2 x double], with each of the two double-precision floating-point vector elements set to the specified double-precision floating-point value.

This intrinsic corresponds to the `VMOVDDUP / MOVLHPS` instruction.

Parameters

  __w | A double-precision floating-point value used to initialize each vector element of the result.

Returns
  An initialized 128-bit floating-point vector of [2 x double].

Definition at line 1837 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_set_pd1().

## ◆ _mm_set_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set_epi16 | ( | short | __w7,
|  | short | __w6,
|  | short | __w5,
|  | short | __w4,
|  | short | __w3,
|  | short | __w2,
|  | short | __w1,
|  | short | __w0
| ) |  |
| static

Initializes the 16-bit values in a 128-bit vector of [8 x i16] with the specified 16-bit integer values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __w7 | A 16-bit integer value used to initialize bits [127:112] of the destination vector.
  __w6 | A 16-bit integer value used to initialize bits [111:96] of the destination vector.
  __w5 | A 16-bit integer value used to initialize bits [95:80] of the destination vector.
  __w4 | A 16-bit integer value used to initialize bits [79:64] of the destination vector.
  __w3 | A 16-bit integer value used to initialize bits [63:48] of the destination vector.
  __w2 | A 16-bit integer value used to initialize bits [47:32] of the destination vector.
  __w1 | A 16-bit integer value used to initialize bits [31:16] of the destination vector.
  __w0 | A 16-bit integer value used to initialize bits [15:0] of the destination vector.

Returns
  An initialized 128-bit vector of [8 x i16] containing the values provided in the operands.

Definition at line 3699 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_set1_epi16(), and _mm_setr_epi16().

## ◆ _mm_set_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set_epi32 | ( | int | __i3,
|  | int | __i2,
|  | int | __i1,
|  | int | __i0
| ) |  |
| static

Initializes the 32-bit values in a 128-bit vector of [4 x i32] with the specified 32-bit integer values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __i3 | A 32-bit integer value used to initialize bits [127:96] of the destination vector.
  __i2 | A 32-bit integer value used to initialize bits [95:64] of the destination vector.
  __i1 | A 32-bit integer value used to initialize bits [63:32] of the destination vector.
  __i0 | A 32-bit integer value used to initialize bits [31:0] of the destination vector.

Returns
  An initialized 128-bit vector of [4 x i32] containing the values provided in the operands.

Definition at line 3659 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_set1_epi32(), and _mm_setr_epi32().

## ◆ _mm_set_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set_epi64 | ( | __m64 | __q1,
|  | __m64 | __q0
| ) |  |
| static

Initializes both 64-bit values in a 128-bit vector of [2 x i64] with the specified 64-bit integer values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __q1 | A 64-bit integer value used to initialize the upper 64 bits of the destination vector of [2 x i64].
  __q0 | A 64-bit integer value used to initialize the lower 64 bits of the destination vector of [2 x i64].

Returns
  An initialized 128-bit vector of [2 x i64] containing the values provided in the operands.

Definition at line 3631 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi64x().

Referenced by _mm_set1_epi64(), and _mm_setr_epi64().

## ◆ _mm_set_epi64x()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set_epi64x | ( | long long | __q1,
|  | long long | __q0
| ) |  |
| static

Initializes both 64-bit values in a 128-bit vector of [2 x i64] with the specified 64-bit integer values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __q1 | A 64-bit integer value used to initialize the upper 64 bits of the destination vector of [2 x i64].
  __q0 | A 64-bit integer value used to initialize the lower 64 bits of the destination vector of [2 x i64].

Returns
  An initialized 128-bit vector of [2 x i64] containing the values provided in the operands.

Definition at line 3609 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_set1_epi64x(), and _mm_set_epi64().

## ◆ _mm_set_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_set_epi8 | ( | char | __b15,
|  | char | __b14,
|  | char | __b13,
|  | char | __b12,
|  | char | __b11,
|  | char | __b10,
|  | char | __b9,
|  | char | __b8,
|  | char | __b7,
|  | char | __b6,
|  | char | __b5,
|  | char | __b4,
|  | char | __b3,
|  | char | __b2,
|  | char | __b1,
|  | char | __b0
| ) |  |
| static

Initializes the 8-bit values in a 128-bit vector of [16 x i8] with the specified 8-bit integer values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __b15 | Initializes bits [127:120] of the destination vector.
  __b14 | Initializes bits [119:112] of the destination vector.
  __b13 | Initializes bits [111:104] of the destination vector.
  __b12 | Initializes bits [103:96] of the destination vector.
  __b11 | Initializes bits [95:88] of the destination vector.
  __b10 | Initializes bits [87:80] of the destination vector.
  __b9 | Initializes bits [79:72] of the destination vector.
  __b8 | Initializes bits [71:64] of the destination vector.
  __b7 | Initializes bits [63:56] of the destination vector.
  __b6 | Initializes bits [55:48] of the destination vector.
  __b5 | Initializes bits [47:40] of the destination vector.
  __b4 | Initializes bits [39:32] of the destination vector.
  __b3 | Initializes bits [31:24] of the destination vector.
  __b2 | Initializes bits [23:16] of the destination vector.
  __b1 | Initializes bits [15:8] of the destination vector.
  __b0 | Initializes bits [7:0] of the destination vector.

Returns
  An initialized 128-bit vector of [16 x i8] containing the values provided in the operands.

Definition at line 3747 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_set1_epi8(), and _mm_setr_epi8().

## ◆ _mm_set_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_set_pd | ( | double | __w,
|  | double | __x
| ) |  |
| static

Constructs a 128-bit floating-point vector of [2 x double] initialized with the specified double-precision floating-point values.

This intrinsic corresponds to the `VUNPCKLPD / UNPCKLPD` instruction.

Parameters

  __w | A double-precision floating-point value used to initialize the upper 64 bits of the result.
  __x | A double-precision floating-point value used to initialize the lower 64 bits of the result.

Returns
  An initialized 128-bit floating-point vector of [2 x double].

Definition at line 1875 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __x.

## ◆ _mm_set_pd1()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_set_pd1 | ( | double | __w | ) |
| static

Constructs a 128-bit floating-point vector of [2 x double], with each of the two double-precision floating-point vector elements set to the specified double-precision floating-point value.

This intrinsic corresponds to the `VMOVDDUP / MOVLHPS` instruction.

Parameters

  __w | A double-precision floating-point value used to initialize each vector element of the result.

Returns
  An initialized 128-bit floating-point vector of [2 x double].

Definition at line 1855 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set1_pd().

## ◆ _mm_set_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_set_sd | ( | double | __w | ) |
| static

Constructs a 128-bit floating-point vector of [2 x double].

The lower 64 bits of the vector are initialized with the specified double-precision floating-point value. The upper 64 bits are set to zero.

This intrinsic corresponds to the `VMOVQ / MOVQ` instruction.

Parameters

  __w | A double-precision floating-point value used to initialize the lower 64 bits of the result.

Returns
  An initialized 128-bit floating-point vector of [2 x double]. The lower 64 bits contain the value of the parameter. The upper 64 bits are set to zero.

Definition at line 1819 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_setr_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setr_epi16 | ( | short | __w0,
|  | short | __w1,
|  | short | __w2,
|  | short | __w3,
|  | short | __w4,
|  | short | __w5,
|  | short | __w6,
|  | short | __w7
| ) |  |
| static

Constructs a 128-bit integer vector, initialized in reverse order with the specified 16-bit integral values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __w0 | A 16-bit integral value used to initialize bits [15:0] of the result.
  __w1 | A 16-bit integral value used to initialize bits [31:16] of the result.
  __w2 | A 16-bit integral value used to initialize bits [47:32] of the result.
  __w3 | A 16-bit integral value used to initialize bits [63:48] of the result.
  __w4 | A 16-bit integral value used to initialize bits [79:64] of the result.
  __w5 | A 16-bit integral value used to initialize bits [95:80] of the result.
  __w6 | A 16-bit integral value used to initialize bits [111:96] of the result.
  __w7 | A 16-bit integral value used to initialize bits [127:112] of the result.

Returns
  An initialized 128-bit integer vector.

Definition at line 3916 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi16().

## ◆ _mm_setr_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setr_epi32 | ( | int | __i0,
|  | int | __i1,
|  | int | __i2,
|  | int | __i3
| ) |  |
| static

Constructs a 128-bit integer vector, initialized in reverse order with the specified 32-bit integral values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __i0 | A 32-bit integral value used to initialize bits [31:0] of the result.
  __i1 | A 32-bit integral value used to initialize bits [63:32] of the result.
  __i2 | A 32-bit integral value used to initialize bits [95:64] of the result.
  __i3 | A 32-bit integral value used to initialize bits [127:96] of the result.

Returns
  An initialized 128-bit integer vector.

Definition at line 3885 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi32().

## ◆ _mm_setr_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setr_epi64 | ( | __m64 | __q0,
|  | __m64 | __q1
| ) |  |
| static

Constructs a 128-bit integer vector, initialized in reverse order with the specified 64-bit integral values.

This intrinsic does not correspond to a specific instruction.

Parameters

  __q0 | A 64-bit integral value used to initialize the lower 64 bits of the result.
  __q1 | A 64-bit integral value used to initialize the upper 64 bits of the result.

Returns
  An initialized 128-bit integer vector.

Definition at line 3862 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi64().

## ◆ _mm_setr_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setr_epi8 | ( | char | __b0,
|  | char | __b1,
|  | char | __b2,
|  | char | __b3,
|  | char | __b4,
|  | char | __b5,
|  | char | __b6,
|  | char | __b7,
|  | char | __b8,
|  | char | __b9,
|  | char | __b10,
|  | char | __b11,
|  | char | __b12,
|  | char | __b13,
|  | char | __b14,
|  | char | __b15
| ) |  |
| static

Constructs a 128-bit integer vector, initialized in reverse order with the specified 8-bit integral values.

This intrinsic is a utility function and does not correspond to a specific instruction.

Parameters

  __b0 | An 8-bit integral value used to initialize bits [7:0] of the result.
  __b1 | An 8-bit integral value used to initialize bits [15:8] of the result.
  __b2 | An 8-bit integral value used to initialize bits [23:16] of the result.
  __b3 | An 8-bit integral value used to initialize bits [31:24] of the result.
  __b4 | An 8-bit integral value used to initialize bits [39:32] of the result.
  __b5 | An 8-bit integral value used to initialize bits [47:40] of the result.
  __b6 | An 8-bit integral value used to initialize bits [55:48] of the result.
  __b7 | An 8-bit integral value used to initialize bits [63:56] of the result.
  __b8 | An 8-bit integral value used to initialize bits [71:64] of the result.
  __b9 | An 8-bit integral value used to initialize bits [79:72] of the result.
  __b10 | An 8-bit integral value used to initialize bits [87:80] of the result.
  __b11 | An 8-bit integral value used to initialize bits [95:88] of the result.
  __b12 | An 8-bit integral value used to initialize bits [103:96] of the result.
  __b13 | An 8-bit integral value used to initialize bits [111:104] of the result.
  __b14 | An 8-bit integral value used to initialize bits [119:112] of the result.
  __b15 | An 8-bit integral value used to initialize bits [127:120] of the result.

Returns
  An initialized 128-bit integer vector.

Definition at line 3963 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_set_epi8().

## ◆ _mm_setr_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_setr_pd | ( | double | __w,
|  | double | __x
| ) |  |
| static

Constructs a 128-bit floating-point vector of [2 x double], initialized in reverse order with the specified double-precision floating-point values.

This intrinsic corresponds to the `VUNPCKLPD / UNPCKLPD` instruction.

Parameters

  __w | A double-precision floating-point value used to initialize the lower 64 bits of the result.
  __x | A double-precision floating-point value used to initialize the upper 64 bits of the result.

Returns
  An initialized 128-bit floating-point vector of [2 x double].

Definition at line 1896 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_setzero_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_setzero_pd | ( | void |  | ) |
| static

Constructs a 128-bit floating-point vector of [2 x double] initialized to zero.

This intrinsic corresponds to the `VXORPS / XORPS` instruction.

Returns
  An initialized 128-bit floating-point vector of [2 x double] with all elements set to zero.

Definition at line 1911 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm256_zextpd128_pd256(), _mm512_zextpd128_pd512(), _mm_getexp_pd(), _mm_getexp_sd(), _mm_mask_load_sd(), _mm_maskz_add_pd(), _mm_maskz_add_sd(), _mm_maskz_and_pd(), _mm_maskz_andnot_pd(), _mm_maskz_compress_pd(), _mm_maskz_cvtepi32_pd(), _mm_maskz_cvtepi64_pd(), _mm_maskz_cvtepu32_pd(), _mm_maskz_cvtepu64_pd(), _mm_maskz_cvtps_pd(), _mm_maskz_cvtss_sd(), _mm_maskz_div_pd(), _mm_maskz_div_sd(), _mm_maskz_expand_pd(), _mm_maskz_expandloadu_pd(), _mm_maskz_fmadd_pd(), _mm_maskz_fmaddsub_pd(), _mm_maskz_fmsub_pd(), _mm_maskz_fmsubadd_pd(), _mm_maskz_fnmadd_pd(), _mm_maskz_fnmsub_pd(), _mm_maskz_getexp_pd(), _mm_maskz_getexp_sd(), _mm_maskz_load_pd(), _mm_maskz_load_sd(), _mm_maskz_loadu_pd(), _mm_maskz_max_pd(), _mm_maskz_max_sd(), _mm_maskz_min_pd(), _mm_maskz_min_sd(), _mm_maskz_mov_pd(), _mm_maskz_move_sd(), _mm_maskz_movedup_pd(), _mm_maskz_mul_pd(), _mm_maskz_mul_sd(), _mm_maskz_or_pd(), _mm_maskz_permutevar_pd(), _mm_maskz_permutex2var_pd(), _mm_maskz_rcp14_pd(), _mm_maskz_rcp14_sd(), _mm_maskz_rsqrt14_pd(), _mm_maskz_rsqrt14_sd(), _mm_maskz_scalef_pd(), _mm_maskz_scalef_sd(), _mm_maskz_sqrt_pd(), _mm_maskz_sqrt_sd(), _mm_maskz_sub_pd(), _mm_maskz_sub_sd(), _mm_maskz_unpackhi_pd(), _mm_maskz_unpacklo_pd(), _mm_maskz_xor_pd(), _mm_rcp14_pd(), _mm_rcp14_sd(), _mm_rsqrt14_pd(), _mm_rsqrt14_sd(), _mm_scalef_pd(), and _mm_scalef_sd().

## ◆ _mm_setzero_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_setzero_si128 | ( | void |  | ) |
| static

Creates a 128-bit integer vector initialized to zero.

This intrinsic corresponds to the `VXORPS / XORPS` instruction.

Returns
  An initialized 128-bit integer vector with all elements set to zero.

Definition at line 3977 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm256_cvtpd_epu32(), _mm256_cvtsepi16_epi8(), _mm256_cvttpd_epu32(), _mm256_cvtusepi16_epi8(), _mm256_maskz_cvtepi16_epi8(), _mm256_maskz_cvtepi32_epi16(), _mm256_maskz_cvtepi32_epi8(), _mm256_maskz_cvtepi64_epi16(), _mm256_maskz_cvtepi64_epi32(), _mm256_maskz_cvtepi64_epi8(), _mm256_maskz_cvtneps_pbh(), _mm256_maskz_cvtpd_epi32(), _mm256_maskz_cvtpd_epu32(), _mm256_maskz_cvtsepi16_epi8(), _mm256_maskz_cvtsepi32_epi16(), _mm256_maskz_cvtsepi32_epi8(), _mm256_maskz_cvtsepi64_epi16(), _mm256_maskz_cvtsepi64_epi32(), _mm256_maskz_cvtsepi64_epi8(), _mm256_maskz_cvttpd_epi32(), _mm256_maskz_cvttpd_epu32(), _mm256_maskz_cvtusepi16_epi8(), _mm256_maskz_cvtusepi32_epi16(), _mm256_maskz_cvtusepi32_epi8(), _mm256_maskz_cvtusepi64_epi16(), _mm256_maskz_cvtusepi64_epi32(), _mm256_maskz_cvtusepi64_epi8(), _mm256_zextsi128_si256(), _mm512_maskz_cvtepi32_epi8(), _mm512_maskz_cvtepi64_epi16(), _mm512_maskz_cvtepi64_epi8(), _mm512_maskz_cvtsepi32_epi8(), _mm512_maskz_cvtsepi64_epi16(), _mm512_maskz_cvtsepi64_epi8(), _mm512_maskz_cvtusepi32_epi8(), _mm512_maskz_cvtusepi64_epi16(), _mm512_maskz_cvtusepi64_epi8(), _mm512_zextsi128_si512(), _mm_cvtpd_epi64(), _mm_cvtpd_epu32(), _mm_cvtpd_epu64(), _mm_cvtps_epi64(), _mm_cvtps_epu32(), _mm_cvtps_epu64(), _mm_cvtsepi16_epi8(), _mm_cvtsepi32_epi16(), _mm_cvttpd_epi64(), _mm_cvttpd_epu32(), _mm_cvttpd_epu64(), _mm_cvttps_epi64(), _mm_cvttps_epu32(), _mm_cvttps_epu64(), _mm_cvtusepi16_epi8(), _mm_mask_test_epi16_mask(), _mm_mask_test_epi32_mask(), _mm_mask_test_epi64_mask(), _mm_mask_test_epi8_mask(), _mm_mask_testn_epi16_mask(), _mm_mask_testn_epi32_mask(), _mm_mask_testn_epi64_mask(), _mm_mask_testn_epi8_mask(), _mm_maskz_abs_epi16(), _mm_maskz_abs_epi32(), _mm_maskz_abs_epi64(), _mm_maskz_abs_epi8(), _mm_maskz_add_epi16(), _mm_maskz_add_epi32(), _mm_maskz_add_epi64(), _mm_maskz_add_epi8(), _mm_maskz_adds_epi16(), _mm_maskz_adds_epi8(), _mm_maskz_adds_epu16(), _mm_maskz_adds_epu8(), _mm_maskz_and_epi32(), _mm_maskz_and_epi64(), _mm_maskz_andnot_epi32(), _mm_maskz_andnot_epi64(), _mm_maskz_avg_epu16(), _mm_maskz_avg_epu8(), _mm_maskz_broadcast_i32x2(), _mm_maskz_broadcastb_epi8(), _mm_maskz_broadcastd_epi32(), _mm_maskz_broadcastq_epi64(), _mm_maskz_broadcastw_epi16(), _mm_maskz_compress_epi16(), _mm_maskz_compress_epi32(), _mm_maskz_compress_epi64(), _mm_maskz_compress_epi8(), _mm_maskz_conflict_epi32(), _mm_maskz_conflict_epi64(), _mm_maskz_cvtepi16_epi32(), _mm_maskz_cvtepi16_epi64(), _mm_maskz_cvtepi16_epi8(), _mm_maskz_cvtepi32_epi16(), _mm_maskz_cvtepi32_epi64(), _mm_maskz_cvtepi32_epi8(), _mm_maskz_cvtepi64_epi16(), _mm_maskz_cvtepi64_epi32(), _mm_maskz_cvtepi64_epi8(), _mm_maskz_cvtepi8_epi16(), _mm_maskz_cvtepi8_epi32(), _mm_maskz_cvtepi8_epi64(), _mm_maskz_cvtepu16_epi32(), _mm_maskz_cvtepu16_epi64(), _mm_maskz_cvtepu32_epi64(), _mm_maskz_cvtepu8_epi16(), _mm_maskz_cvtepu8_epi32(), _mm_maskz_cvtepu8_epi64(), _mm_maskz_cvtne2ps_pbh(), _mm_maskz_cvtneps_pbh(), _mm_maskz_cvtpd_epi32(), _mm_maskz_cvtpd_epi64(), _mm_maskz_cvtpd_epu32(), _mm_maskz_cvtpd_epu64(), _mm_maskz_cvtps_epi32(), _mm_maskz_cvtps_epi64(), _mm_maskz_cvtps_epu32(), _mm_maskz_cvtps_epu64(), _mm_maskz_cvtsepi16_epi8(), _mm_maskz_cvtsepi32_epi16(), _mm_maskz_cvtsepi32_epi8(), _mm_maskz_cvtsepi64_epi16(), _mm_maskz_cvtsepi64_epi32(), _mm_maskz_cvtsepi64_epi8(), _mm_maskz_cvttpd_epi32(), _mm_maskz_cvttpd_epi64(), _mm_maskz_cvttpd_epu32(), _mm_maskz_cvttpd_epu64(), _mm_maskz_cvttps_epi32(), _mm_maskz_cvttps_epi64(), _mm_maskz_cvttps_epu32(), _mm_maskz_cvttps_epu64(), _mm_maskz_cvtusepi16_epi8(), _mm_maskz_cvtusepi32_epi16(), _mm_maskz_cvtusepi32_epi8(), _mm_maskz_cvtusepi64_epi16(), _mm_maskz_cvtusepi64_epi32(), _mm_maskz_cvtusepi64_epi8(), _mm_maskz_dpbf16_ps(), _mm_maskz_dpbusd_epi32(), _mm_maskz_dpbusds_epi32(), _mm_maskz_dpwssd_epi32(), _mm_maskz_dpwssds_epi32(), _mm_maskz_expand_epi16(), _mm_maskz_expand_epi32(), _mm_maskz_expand_epi64(), _mm_maskz_expand_epi8(), _mm_maskz_expandloadu_epi16(), _mm_maskz_expandloadu_epi32(), _mm_maskz_expandloadu_epi64(), _mm_maskz_expandloadu_epi8(), _mm_maskz_gf2p8mul_epi8(), _mm_maskz_load_epi32(), _mm_maskz_load_epi64(), _mm_maskz_loadu_epi16(), _mm_maskz_loadu_epi32(), _mm_maskz_loadu_epi64(), _mm_maskz_loadu_epi8(), _mm_maskz_lzcnt_epi32(), _mm_maskz_lzcnt_epi64(), _mm_maskz_madd52hi_epu64(), _mm_maskz_madd52lo_epu64(), _mm_maskz_madd_epi16(), _mm_maskz_maddubs_epi16(), _mm_maskz_max_epi16(), _mm_maskz_max_epi32(), _mm_maskz_max_epi64(), _mm_maskz_max_epi8(), _mm_maskz_max_epu16(), _mm_maskz_max_epu32(), _mm_maskz_max_epu64(), _mm_maskz_max_epu8(), _mm_maskz_min_epi16(), _mm_maskz_min_epi32(), _mm_maskz_min_epi64(), _mm_maskz_min_epi8(), _mm_maskz_min_epu16(), _mm_maskz_min_epu32(), _mm_maskz_min_epu64(), _mm_maskz_min_epu8(), _mm_maskz_mov_epi16(), _mm_maskz_mov_epi32(), _mm_maskz_mov_epi64(), _mm_maskz_mov_epi8(), _mm_maskz_mul_epi32(), _mm_maskz_mul_epu32(), _mm_maskz_mulhi_epi16(), _mm_maskz_mulhi_epu16(), _mm_maskz_mulhrs_epi16(), _mm_maskz_mullo_epi16(), _mm_maskz_mullo_epi32(), _mm_maskz_mullo_epi64(), _mm_maskz_multishift_epi64_epi8(), _mm_maskz_or_epi32(), _mm_maskz_or_epi64(), _mm_maskz_packs_epi16(), _mm_maskz_packs_epi32(), _mm_maskz_packus_epi16(), _mm_maskz_packus_epi32(), _mm_maskz_permutex2var_epi16(), _mm_maskz_permutex2var_epi32(), _mm_maskz_permutex2var_epi64(), _mm_maskz_permutex2var_epi8(), _mm_maskz_permutexvar_epi16(), _mm_maskz_permutexvar_epi8(), _mm_maskz_popcnt_epi16(), _mm_maskz_popcnt_epi32(), _mm_maskz_popcnt_epi64(), _mm_maskz_popcnt_epi8(), _mm_maskz_rolv_epi32(), _mm_maskz_rolv_epi64(), _mm_maskz_rorv_epi32(), _mm_maskz_rorv_epi64(), _mm_maskz_set1_epi16(), _mm_maskz_set1_epi32(), _mm_maskz_set1_epi64(), _mm_maskz_set1_epi8(), _mm_maskz_shldv_epi16(), _mm_maskz_shldv_epi32(), _mm_maskz_shldv_epi64(), _mm_maskz_shrdv_epi16(), _mm_maskz_shrdv_epi32(), _mm_maskz_shrdv_epi64(), _mm_maskz_shuffle_epi8(), _mm_maskz_sll_epi16(), _mm_maskz_sll_epi32(), _mm_maskz_sll_epi64(), _mm_maskz_slli_epi16(), _mm_maskz_slli_epi32(), _mm_maskz_slli_epi64(), _mm_maskz_sllv_epi16(), _mm_maskz_sllv_epi32(), _mm_maskz_sllv_epi64(), _mm_maskz_sra_epi16(), _mm_maskz_sra_epi32(), _mm_maskz_sra_epi64(), _mm_maskz_srai_epi16(), _mm_maskz_srai_epi32(), _mm_maskz_srai_epi64(), _mm_maskz_srav_epi16(), _mm_maskz_srav_epi32(), _mm_maskz_srav_epi64(), _mm_maskz_srl_epi16(), _mm_maskz_srl_epi32(), _mm_maskz_srl_epi64(), _mm_maskz_srli_epi16(), _mm_maskz_srli_epi32(), _mm_maskz_srli_epi64(), _mm_maskz_srlv_epi16(), _mm_maskz_srlv_epi32(), _mm_maskz_srlv_epi64(), _mm_maskz_sub_epi16(), _mm_maskz_sub_epi32(), _mm_maskz_sub_epi64(), _mm_maskz_sub_epi8(), _mm_maskz_subs_epi16(), _mm_maskz_subs_epi8(), _mm_maskz_subs_epu16(), _mm_maskz_subs_epu8(), _mm_maskz_unpackhi_epi16(), _mm_maskz_unpackhi_epi32(), _mm_maskz_unpackhi_epi64(), _mm_maskz_unpackhi_epi8(), _mm_maskz_unpacklo_epi16(), _mm_maskz_unpacklo_epi32(), _mm_maskz_unpacklo_epi64(), _mm_maskz_unpacklo_epi8(), _mm_maskz_xor_epi32(), _mm_maskz_xor_epi64(), _mm_move_epi64(), _mm_test_epi16_mask(), _mm_test_epi32_mask(), _mm_test_epi64_mask(), _mm_test_epi8_mask(), _mm_testn_epi16_mask(), _mm_testn_epi32_mask(), _mm_testn_epi64_mask(), and _mm_testn_epi8_mask().

## ◆ _mm_sll_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sll_epi16 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Left-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLW / PSLLW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2859 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sll_epi16(), and _mm_maskz_sll_epi16().

## ◆ _mm_sll_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sll_epi32 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Left-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLD / PSLLD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2897 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sll_epi32(), and _mm_maskz_sll_epi32().

## ◆ _mm_sll_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sll_epi64 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Left-shifts each 64-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLQ / PSLLQ` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2935 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sll_epi64(), and _mm_maskz_sll_epi64().

## ◆ _mm_slli_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_slli_epi16 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Left-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLW / PSLLW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2840 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_slli_epi16(), and _mm_maskz_slli_epi16().

## ◆ _mm_slli_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_slli_epi32 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Left-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLD / PSLLD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2878 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_slli_epi32(), and _mm_maskz_slli_epi32().

## ◆ _mm_slli_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_slli_epi64 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Left-shifts each 64-bit value in the 128-bit integer vector operand by the specified number of bits.

Low-order bits are cleared.

This intrinsic corresponds to the `VPSLLQ / PSLLQ` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to left-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the left-shifted values.

Definition at line 2916 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_slli_epi64(), and _mm_maskz_slli_epi64().

## ◆ _mm_sqrt_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_sqrt_pd | ( | __m128d | __a | ) |
| static

Calculates the square root of the each of two values stored in a 128-bit vector of [2 x double].

This intrinsic corresponds to the `VSQRTPD / SQRTPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double].

Returns
  A 128-bit vector of [2 x double] containing the square roots of the values in the operand.

Definition at line 244 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sqrt_pd(), and _mm_maskz_sqrt_pd().

## ◆ _mm_sqrt_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_sqrt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Calculates the square root of the lower double-precision value of the second operand and returns it in the lower 64 bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VSQRTSD / SQRTSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the operands. The upper 64 bits of this operand are copied to the upper 64 bits of the result.
  __b | A 128-bit vector of [2 x double] containing one of the operands. The square root is calculated using the lower 64 bits of this operand.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the square root of the lower 64 bits of operand __b, and whose upper 64 bits are copied from the upper 64 bits of operand __a.

Definition at line 226 of file emmintrin.h.

References __c, and __DEFAULT_FN_ATTRS.

## ◆ _mm_sra_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sra_epi16 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Right-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits.

High-order bits are filled with the sign bit of the initial value.

This intrinsic corresponds to the `VPSRAW / PSRAW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 2975 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sra_epi16(), and _mm_maskz_sra_epi16().

## ◆ _mm_sra_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sra_epi32 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Right-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits.

High-order bits are filled with the sign bit of the initial value.

This intrinsic corresponds to the `VPSRAD / PSRAD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3015 of file emmintrin.h.

Referenced by _mm_mask_sra_epi32(), and _mm_maskz_sra_epi32().

## ◆ _mm_srai_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srai_epi16 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Right-shifts each 16-bit value in the 128-bit integer vector operand by the specified number of bits.

High-order bits are filled with the sign bit of the initial value.

This intrinsic corresponds to the `VPSRAW / PSRAW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 2955 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srai_epi16(), and _mm_maskz_srai_epi16().

## ◆ _mm_srai_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srai_epi32 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Right-shifts each 32-bit value in the 128-bit integer vector operand by the specified number of bits.

High-order bits are filled with the sign bit of the initial value.

This intrinsic corresponds to the `VPSRAD / PSRAD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 2995 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srai_epi32(), and _mm_maskz_srai_epi32().

## ◆ _mm_srl_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srl_epi16 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Right-shifts each of 16-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLW / PSRLW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3076 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srl_epi16(), and _mm_maskz_srl_epi16().

## ◆ _mm_srl_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srl_epi32 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Right-shifts each of 32-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLD / PSRLD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3114 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srl_epi32(), and _mm_maskz_srl_epi32().

## ◆ _mm_srl_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srl_epi64 | ( | __m128i | __a,
|  | __m128i | __count
| ) |  |
| static

Right-shifts each of 64-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLQ / PSRLQ` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | A 128-bit integer vector in which bits [63:0] specify the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3152 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srl_epi64(), and _mm_maskz_srl_epi64().

## ◆ _mm_srli_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srli_epi16 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Right-shifts each of 16-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLW / PSRLW` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3057 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srli_epi16(), and _mm_maskz_srli_epi16().

## ◆ _mm_srli_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srli_epi32 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Right-shifts each of 32-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLD / PSRLD` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3095 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srli_epi32(), and _mm_maskz_srli_epi32().

## ◆ _mm_srli_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_srli_epi64 | ( | __m128i | __a,
|  | int | __count
| ) |  |
| static

Right-shifts each of 64-bit values in the 128-bit integer vector operand by the specified number of bits.

High-order bits are cleared.

This intrinsic corresponds to the `VPSRLQ / PSRLQ` instruction.

Parameters

  __a | A 128-bit integer vector containing the source operand.
  __count | An integer value specifying the number of bits to right-shift each value in operand __a.

Returns
  A 128-bit integer vector containing the right-shifted values.

Definition at line 3133 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_srli_epi64(), and _mm_maskz_srli_epi64().

## ◆ _mm_store1_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_store1_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Moves the lower 64 bits of a 128-bit vector of [2 x double] twice to the upper and lower 64 bits of a memory location.

This intrinsic corresponds to the `VMOVDDUP + VMOVAPD / MOVLHPS + MOVAPS` instruction.

Parameters

  __dp | A pointer to a memory location that can store two double-precision values.
  __a | A 128-bit vector of [2 x double] whose lower 64 bits are copied to each of the values in __dp.

Definition at line 1992 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_store_pd().

Referenced by _mm_store_pd1().

## ◆ _mm_store_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_store_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Moves packed double-precision values from a 128-bit vector of [2 x double] to a memory location.

This intrinsic corresponds to the `VMOVAPD / MOVAPS` instruction.

Parameters

  __dp | A pointer to an aligned memory location that can store two double-precision values.
  __a | A packed 128-bit vector of [2 x double] containing the values to be moved.

Definition at line 1972 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_store1_pd().

## ◆ _mm_store_pd1()

static __inline__ void __DEFAULT_FN_ATTRS _mm_store_pd1 | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Moves the lower 64 bits of a 128-bit vector of [2 x double] twice to the upper and lower 64 bits of a memory location.

This intrinsic corresponds to the `VMOVDDUP + VMOVAPD / MOVLHPS + MOVAPS` instruction.

Parameters

  __dp | A pointer to a memory location that can store two double-precision values.
  __a | A 128-bit vector of [2 x double] whose lower 64 bits are copied to each of the values in __dp.

Definition at line 2013 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and _mm_store1_pd().

## ◆ _mm_store_sd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_store_sd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Stores the lower 64 bits of a 128-bit vector of [2 x double] to a memory location.

This intrinsic corresponds to the `VMOVSD / MOVSD` instruction.

Parameters

  __dp | A pointer to a 64-bit memory location.
  __a | A 128-bit vector of [2 x double] containing the value to be stored.

Definition at line 1950 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_store_si128()

static __inline__ void __DEFAULT_FN_ATTRS _mm_store_si128 | ( | __m128i * | __p,
|  | __m128i | __b
| ) |  |
| static

Stores a 128-bit integer vector to a memory location aligned on a 128-bit boundary.

This intrinsic corresponds to the `VMOVAPS / MOVAPS` instruction.

Parameters

  __p | A pointer to an aligned memory location that will receive the integer values.
  __b | A 128-bit integer vector containing the values to be moved.

Definition at line 3995 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

## ◆ _mm_storeh_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeh_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Stores the upper 64 bits of a 128-bit vector of [2 x double] to a memory location.

This intrinsic corresponds to the `VMOVHPD / MOVHPD` instruction.

Parameters

  __dp | A pointer to a 64-bit memory location.
  __a | A 128-bit vector of [2 x double] containing the value to be stored.

Definition at line 2072 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_storel_epi64()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storel_epi64 | ( | __m128i_u * | __p,
|  | __m128i | __a
| ) |  |
| static

Stores the lower 64 bits of a 128-bit integer vector of [2 x i64] to a memory location.

This intrinsic corresponds to the `VMOVLPS / MOVLPS` instruction.

Parameters

  __p | A pointer to a 64-bit memory location that will receive the lower 64 bits of the integer vector parameter.
  __a | A 128-bit integer vector of [2 x i64]. The lower 64 bits contain the value to be stored.

Definition at line 4123 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_storel_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storel_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Stores the lower 64 bits of a 128-bit vector of [2 x double] to a memory location.

This intrinsic corresponds to the `VMOVLPD / MOVLPD` instruction.

Parameters

  __dp | A pointer to a 64-bit memory location.
  __a | A 128-bit vector of [2 x double] containing the value to be stored.

Definition at line 2092 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_storer_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storer_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Stores two double-precision values, in reverse order, from a 128-bit vector of [2 x double] to a 16-byte aligned memory location.

This intrinsic corresponds to a shuffling instruction followed by a `VMOVAPD / MOVAPD` instruction.

Parameters

  __dp | A pointer to a 16-byte aligned memory location that can store two double-precision values.
  __a | A 128-bit vector of [2 x double] containing the values to be reversed and stored.

Definition at line 2054 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_storeu_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeu_pd | ( | double * | __dp,
|  | __m128d | __a
| ) |  |
| static

Stores a 128-bit vector of [2 x double] into an unaligned memory location.

This intrinsic corresponds to the `VMOVUPD / MOVUPD` instruction.

Parameters

  __dp | A pointer to a 128-bit memory location. The address of the memory location does not have to be aligned.
  __a | A 128-bit vector of [2 x double] containing the values to be stored.

Definition at line 2031 of file emmintrin.h.

References __a, __DEFAULT_FN_ATTRS, and __v.

Referenced by _mm256_storeu2_m128d().

## ◆ _mm_storeu_si128()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeu_si128 | ( | __m128i_u * | __p,
|  | __m128i | __b
| ) |  |
| static

Stores a 128-bit integer vector to an unaligned memory location.

This intrinsic corresponds to the `VMOVUPS / MOVUPS` instruction.

Parameters

  __p | A pointer to a memory location that will receive the integer values.
  __b | A 128-bit integer vector containing the values to be moved.

Definition at line 4011 of file emmintrin.h.

References __b, __DEFAULT_FN_ATTRS, and __v.

Referenced by _mm256_storeu2_m128i().

## ◆ _mm_storeu_si16()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeu_si16 | ( | void * | __p,
|  | __m128i | __b
| ) |  |
| static

Stores a 16-bit integer value from the low element of a 128-bit integer vector.

This intrinsic does not correspond to a specific instruction.

Parameters

  __p | A pointer to a 16-bit memory location. The address of the memory location does not have to be aligned.
  __b | A 128-bit integer vector containing the value to be stored.

Definition at line 4074 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_storeu_si32()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeu_si32 | ( | void * | __p,
|  | __m128i | __b
| ) |  |
| static

Stores a 32-bit integer value from the low element of a 128-bit integer vector.

This intrinsic corresponds to the `VMOVD / MOVD` instruction.

Parameters

  __p | A pointer to a 32-bit memory location. The address of the memory location does not have to be aligned.
  __b | A 128-bit integer vector containing the value to be stored.

Definition at line 4053 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_storeu_si64()

static __inline__ void __DEFAULT_FN_ATTRS _mm_storeu_si64 | ( | void * | __p,
|  | __m128i | __b
| ) |  |
| static

Stores a 64-bit integer value from the low element of a 128-bit integer vector.

This intrinsic corresponds to the `VMOVQ / MOVQ` instruction.

Parameters

  __p | A pointer to a 64-bit memory location. The address of the memory location does not have to be algned.
  __b | A 128-bit integer vector containing the value to be stored.

Definition at line 4032 of file emmintrin.h.

References __DEFAULT_FN_ATTRS, and __v.

## ◆ _mm_stream_pd()

static __inline__ void __DEFAULT_FN_ATTRS _mm_stream_pd | ( | double * | __p,
|  | __m128d | __a
| ) |  |
| static

Stores a 128-bit floating point vector of [2 x double] to a 128-bit aligned memory location.

To minimize caching, the data is flagged as non-temporal (unlikely to be used again soon).

This intrinsic corresponds to the `VMOVNTPS / MOVNTPS` instruction.

Parameters

  __p | A pointer to the 128-bit aligned memory location used to store the value.
  __a | A vector of [2 x double] containing the 64-bit values to be stored.

Definition at line 4146 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_stream_si128()

static __inline__ void __DEFAULT_FN_ATTRS _mm_stream_si128 | ( | __m128i * | __p,
|  | __m128i | __a
| ) |  |
| static

Stores a 128-bit integer vector to a 128-bit aligned memory location.

To minimize caching, the data is flagged as non-temporal (unlikely to be used again soon).

This intrinsic corresponds to the `VMOVNTPS / MOVNTPS` instruction.

Parameters

  __p | A pointer to the 128-bit aligned memory location used to store the value.
  __a | A 128-bit integer vector containing the values to be stored.

Definition at line 4165 of file emmintrin.h.

References __p.

## ◆ _mm_sub_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sub_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts the corresponding 16-bit integer values in the operands.

This intrinsic corresponds to the `VPSUBW / PSUBW` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2588 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sub_epi16(), and _mm_maskz_sub_epi16().

## ◆ _mm_sub_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sub_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts the corresponding 32-bit integer values in the operands.

This intrinsic corresponds to the `VPSUBD / PSUBD` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2606 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS_MMX.

Referenced by _mm_mask_sub_epi32(), and _mm_maskz_sub_epi32().

## ◆ _mm_sub_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sub_epi64 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts the corresponding elements of two [2 x i64] vectors.

This intrinsic corresponds to the `VPSUBQ / PSUBQ` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2643 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sub_epi64(), and _mm_maskz_sub_epi64().

## ◆ _mm_sub_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_sub_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts the corresponding 8-bit integer values in the operands.

This intrinsic corresponds to the `VPSUBB / PSUBB` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2570 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sub_epi8(), and _mm_maskz_sub_epi8().

## ◆ _mm_sub_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_sub_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Subtracts two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VSUBPD / SUBPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the minuend.
  __b | A 128-bit vector of [2 x double] containing the subtrahend.

Returns
  A 128-bit vector of [2 x double] containing the differences between both operands.

Definition at line 117 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sub_pd(), and _mm_maskz_sub_pd().

## ◆ _mm_sub_sd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_sub_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Subtracts the lower double-precision value of the second operand from the lower double-precision value of the first operand and returns the difference in the lower 64 bits of the result.

The upper 64 bits of the result are copied from the upper double-precision value of the first operand.

This intrinsic corresponds to the `VSUBSD / SUBSD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing the minuend.
  __b | A 128-bit vector of [2 x double] containing the subtrahend.

Returns
  A 128-bit vector of [2 x double] whose lower 64 bits contain the difference of the lower 64 bits of both operands. The upper 64 bits are copied from the upper 64 bits of the first source operand.

Definition at line 98 of file emmintrin.h.

References __a, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_sub_sd(), and _mm_maskz_sub_sd().

## ◆ _mm_sub_si64()

static __inline__ __m64 __DEFAULT_FN_ATTRS_MMX _mm_sub_si64 | ( | __m64 | __a,
|  | __m64 | __b
| ) |  |
| static

Subtracts signed or unsigned 64-bit integer values and writes the difference to the corresponding bits in the destination.

This intrinsic corresponds to the `PSUBQ` instruction.

Parameters

  __a | A 64-bit integer vector containing the minuend.
  __b | A 64-bit integer vector containing the subtrahend.

Returns
  A 64-bit integer vector containing the difference of the values in the operands.

Definition at line 2625 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_subs_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_subs_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts corresponding 16-bit signed integer values in the input and returns the differences in the corresponding bytes in the destination.

Differences greater than 0x7FFF are saturated to 0x7FFF, and values less than 0x8000 are saturated to 0x8000.

This intrinsic corresponds to the `VPSUBSW / PSUBSW` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2685 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_subs_epi16(), and _mm_maskz_subs_epi16().

## ◆ _mm_subs_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_subs_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts corresponding 8-bit signed integer values in the input and returns the differences in the corresponding bytes in the destination.

Differences greater than 0x7F are saturated to 0x7F, and differences less than 0x80 are saturated to 0x80.

This intrinsic corresponds to the `VPSUBSB / PSUBSB` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the differences of the values in the operands.

Definition at line 2664 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_subs_epi8(), and _mm_maskz_subs_epi8().

## ◆ _mm_subs_epu16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_subs_epu16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts corresponding 16-bit unsigned integer values in the input and returns the differences in the corresponding bytes in the destination.

Differences less than 0x0000 are saturated to 0x0000.

This intrinsic corresponds to the `VPSUBUSW / PSUBUSW` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the unsigned integer differences of the values in the operands.

Definition at line 2725 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_subs_epu16(), and _mm_maskz_subs_epu16().

## ◆ _mm_subs_epu8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_subs_epu8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Subtracts corresponding 8-bit unsigned integer values in the input and returns the differences in the corresponding bytes in the destination.

Differences less than 0x00 are saturated to 0x00.

This intrinsic corresponds to the `VPSUBUSB / PSUBUSB` instruction.

Parameters

  __a | A 128-bit integer vector containing the minuends.
  __b | A 128-bit integer vector containing the subtrahends.

Returns
  A 128-bit integer vector containing the unsigned integer differences of the values in the operands.

Definition at line 2705 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_subs_epu8(), and _mm_maskz_subs_epu8().

## ◆ _mm_ucomieq_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomieq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] for equality.

The comparison yields 0 for false, 1 for true.

If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1146 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_ucomige_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomige_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than or equal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1250 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_ucomigt_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomigt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is greater than the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1224 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_ucomile_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomile_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than or equal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1198 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_ucomilt_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomilt_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is less than the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 0 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison results. If either of the two lower double-precision values is NaN, 0 is returned.

Definition at line 1172 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_ucomineq_sd()

static __inline__ int __DEFAULT_FN_ATTRS _mm_ucomineq_sd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Compares the lower double-precision floating-point values in each of the two 128-bit floating-point vectors of [2 x double] to determine if the value in the first parameter is unequal to the corresponding value in the second parameter.

The comparison yields 0 for false, 1 for true. If either of the two lower double-precision values is NaN, 1 is returned.

This intrinsic corresponds to the `VUCOMISD / UCOMISD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __b.
  __b | A 128-bit vector of [2 x double]. The lower double-precision value is compared to the lower double-precision value of __a.

Returns
  An integer containing the comparison result. If either of the two lower double-precision values is NaN, 1 is returned.

Definition at line 1276 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_undefined_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_undefined_pd | ( | void |  | ) |
| static

Constructs a 128-bit floating-point vector of [2 x double] with unspecified content.

This could be used as an argument to another intrinsic function where the argument is required but the value is not actually used.

This intrinsic has no corresponding instruction.

Returns
  A 128-bit floating-point vector of [2 x double] with unspecified content.

Definition at line 1799 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

## ◆ _mm_undefined_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_undefined_si128 | ( | void |  | ) |
| static

Generates a 128-bit vector of [4 x i32] with unspecified content.

This could be used as an argument to another intrinsic function where the argument is required but the value is not actually used.

This intrinsic has no corresponding instruction.

Returns
  A 128-bit vector of [4 x i32] with unspecified content.

Definition at line 3587 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm256_cvtneps_pbh(), _mm256_cvtsepi32_epi16(), _mm256_cvtsepi32_epi8(), _mm256_cvtsepi64_epi16(), _mm256_cvtsepi64_epi32(), _mm256_cvtsepi64_epi8(), _mm256_cvtusepi32_epi16(), _mm256_cvtusepi32_epi8(), _mm256_cvtusepi64_epi16(), _mm256_cvtusepi64_epi32(), _mm256_cvtusepi64_epi8(), _mm512_cvtepi32_epi8(), _mm512_cvtepi64_epi16(), _mm512_cvtepi64_epi8(), _mm512_cvtsepi32_epi8(), _mm512_cvtsepi64_epi16(), _mm512_cvtsepi64_epi8(), _mm512_cvtusepi32_epi8(), _mm512_cvtusepi64_epi16(), _mm512_cvtusepi64_epi8(), _mm_cvtneps_pbh(), _mm_cvtness_sbh(), _mm_cvtsepi32_epi8(), _mm_cvtsepi64_epi16(), _mm_cvtsepi64_epi32(), _mm_cvtsepi64_epi8(), _mm_cvtusepi32_epi16(), _mm_cvtusepi32_epi8(), _mm_cvtusepi64_epi16(), _mm_cvtusepi64_epi32(), and _mm_cvtusepi64_epi8().

## ◆ _mm_unpackhi_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpackhi_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the high-order (index 4-7) values from two 128-bit vectors of [8 x i16] and interleaves them into a 128-bit vector of [8 x i16].

This intrinsic corresponds to the `VPUNPCKHWD / PUNPCKHWD` instruction.

Parameters

  __a | A 128-bit vector of [8 x i16]. Bits [79:64] are written to bits [15:0] of the result. Bits [95:80] are written to bits [47:32] of the result. Bits [111:96] are written to bits [79:64] of the result. Bits [127:112] are written to bits [111:96] of the result.
  __b | A 128-bit vector of [8 x i16]. Bits [79:64] are written to bits [31:16] of the result. Bits [95:80] are written to bits [63:48] of the result. Bits [111:96] are written to bits [95:80] of the result. Bits [127:112] are written to bits [127:112] of the result.

Returns
  A 128-bit vector of [8 x i16] containing the interleaved values.

Definition at line 4552 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpackhi_epi16(), and _mm_maskz_unpackhi_epi16().

## ◆ _mm_unpackhi_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpackhi_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the high-order (index 2,3) values from two 128-bit vectors of [4 x i32] and interleaves them into a 128-bit vector of [4 x i32].

This intrinsic corresponds to the `VPUNPCKHDQ / PUNPCKHDQ` instruction.

Parameters

  __a | A 128-bit vector of [4 x i32]. Bits [95:64] are written to bits [31:0] of the destination. Bits [127:96] are written to bits [95:64] of the destination.
  __b | A 128-bit vector of [4 x i32]. Bits [95:64] are written to bits [64:32] of the destination. Bits [127:96] are written to bits [127:96] of the destination.

Returns
  A 128-bit vector of [4 x i32] containing the interleaved values.

Definition at line 4575 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpackhi_epi32(), and _mm_maskz_unpackhi_epi32().

## ◆ _mm_unpackhi_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpackhi_epi64 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the high-order 64-bit elements from two 128-bit vectors of [2 x i64] and interleaves them into a 128-bit vector of [2 x i64].

This intrinsic corresponds to the `VPUNPCKHQDQ / PUNPCKHQDQ` instruction.

Parameters

  __a | A 128-bit vector of [2 x i64]. Bits [127:64] are written to bits [63:0] of the destination.
  __b | A 128-bit vector of [2 x i64]. Bits [127:64] are written to bits [127:64] of the destination.

Returns
  A 128-bit vector of [2 x i64] containing the interleaved values.

Definition at line 4596 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpackhi_epi64(), and _mm_maskz_unpackhi_epi64().

## ◆ _mm_unpackhi_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpackhi_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the high-order (index 8-15) values from two 128-bit vectors of [16 x i8] and interleaves them into a 128-bit vector of [16 x i8].

This intrinsic corresponds to the `VPUNPCKHBW / PUNPCKHBW` instruction.

Parameters

  __a | A 128-bit vector of [16 x i8]. Bits [71:64] are written to bits [7:0] of the result. Bits [79:72] are written to bits [23:16] of the result. Bits [87:80] are written to bits [39:32] of the result. Bits [95:88] are written to bits [55:48] of the result. Bits [103:96] are written to bits [71:64] of the result. Bits [111:104] are written to bits [87:80] of the result. Bits [119:112] are written to bits [103:96] of the result. Bits [127:120] are written to bits [119:112] of the result.
  __b | A 128-bit vector of [16 x i8]. Bits [71:64] are written to bits [15:8] of the result. Bits [79:72] are written to bits [31:24] of the result. Bits [87:80] are written to bits [47:40] of the result. Bits [95:88] are written to bits [63:56] of the result. Bits [103:96] are written to bits [79:72] of the result. Bits [111:104] are written to bits [95:88] of the result. Bits [119:112] are written to bits [111:104] of the result. Bits [127:120] are written to bits [127:120] of the result.

Returns
  A 128-bit vector of [16 x i8] containing the interleaved values.

Definition at line 4525 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpackhi_epi8(), and _mm_maskz_unpackhi_epi8().

## ◆ _mm_unpackhi_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_unpackhi_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Unpacks the high-order 64-bit elements from two 128-bit vectors of [2 x double] and interleaves them into a 128-bit vector of [2 x double].

This intrinsic corresponds to the `VUNPCKHPD / UNPCKHPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. Bits [127:64] are written to bits [63:0] of the destination.
  __b | A 128-bit vector of [2 x double]. Bits [127:64] are written to bits [127:64] of the destination.

Returns
  A 128-bit vector of [2 x double] containing the interleaved values.

Definition at line 4776 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpackhi_pd(), and _mm_maskz_unpackhi_pd().

## ◆ _mm_unpacklo_epi16()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpacklo_epi16 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the low-order (index 0-3) values from each of the two 128-bit vectors of [8 x i16] and interleaves them into a 128-bit vector of [8 x i16].

This intrinsic corresponds to the `VPUNPCKLWD / PUNPCKLWD` instruction.

Parameters

  __a | A 128-bit vector of [8 x i16]. Bits [15:0] are written to bits [15:0] of the result. Bits [31:16] are written to bits [47:32] of the result. Bits [47:32] are written to bits [79:64] of the result. Bits [63:48] are written to bits [111:96] of the result.
  __b | A 128-bit vector of [8 x i16]. Bits [15:0] are written to bits [31:16] of the result. Bits [31:16] are written to bits [63:48] of the result. Bits [47:32] are written to bits [95:80] of the result. Bits [63:48] are written to bits [127:112] of the result.

Returns
  A 128-bit vector of [8 x i16] containing the interleaved values.

Definition at line 4659 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpacklo_epi16(), and _mm_maskz_unpacklo_epi16().

## ◆ _mm_unpacklo_epi32()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpacklo_epi32 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the low-order (index 0,1) values from two 128-bit vectors of [4 x i32] and interleaves them into a 128-bit vector of [4 x i32].

This intrinsic corresponds to the `VPUNPCKLDQ / PUNPCKLDQ` instruction.

Parameters

  __a | A 128-bit vector of [4 x i32]. Bits [31:0] are written to bits [31:0] of the destination. Bits [63:32] are written to bits [95:64] of the destination.
  __b | A 128-bit vector of [4 x i32]. Bits [31:0] are written to bits [64:32] of the destination. Bits [63:32] are written to bits [127:96] of the destination.

Returns
  A 128-bit vector of [4 x i32] containing the interleaved values.

Definition at line 4682 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpacklo_epi32(), and _mm_maskz_unpacklo_epi32().

## ◆ _mm_unpacklo_epi64()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpacklo_epi64 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the low-order 64-bit elements from two 128-bit vectors of [2 x i64] and interleaves them into a 128-bit vector of [2 x i64].

This intrinsic corresponds to the `VPUNPCKLQDQ / PUNPCKLQDQ` instruction.

Parameters

  __a | A 128-bit vector of [2 x i64]. Bits [63:0] are written to bits [63:0] of the destination.
  __b | A 128-bit vector of [2 x i64]. Bits [63:0] are written to bits [127:64] of the destination.

Returns
  A 128-bit vector of [2 x i64] containing the interleaved values.

Definition at line 4703 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpacklo_epi64(), and _mm_maskz_unpacklo_epi64().

## ◆ _mm_unpacklo_epi8()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_unpacklo_epi8 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Unpacks the low-order (index 0-7) values from two 128-bit vectors of [16 x i8] and interleaves them into a 128-bit vector of [16 x i8].

This intrinsic corresponds to the `VPUNPCKLBW / PUNPCKLBW` instruction.

Parameters

  __a | A 128-bit vector of [16 x i8]. Bits [7:0] are written to bits [7:0] of the result. Bits [15:8] are written to bits [23:16] of the result. Bits [23:16] are written to bits [39:32] of the result. Bits [31:24] are written to bits [55:48] of the result. Bits [39:32] are written to bits [71:64] of the result. Bits [47:40] are written to bits [87:80] of the result. Bits [55:48] are written to bits [103:96] of the result. Bits [63:56] are written to bits [119:112] of the result.
  __b | A 128-bit vector of [16 x i8]. Bits [7:0] are written to bits [15:8] of the result. Bits [15:8] are written to bits [31:24] of the result. Bits [23:16] are written to bits [47:40] of the result. Bits [31:24] are written to bits [63:56] of the result. Bits [39:32] are written to bits [79:72] of the result. Bits [47:40] are written to bits [95:88] of the result. Bits [55:48] are written to bits [111:104] of the result. Bits [63:56] are written to bits [127:120] of the result.

Returns
  A 128-bit vector of [16 x i8] containing the interleaved values.

Definition at line 4631 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpacklo_epi8(), and _mm_maskz_unpacklo_epi8().

## ◆ _mm_unpacklo_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_unpacklo_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Unpacks the low-order 64-bit elements from two 128-bit vectors of [2 x double] and interleaves them into a 128-bit vector of [2 x double].

This intrinsic corresponds to the `VUNPCKLPD / UNPCKLPD` instruction.

Parameters

  __a | A 128-bit vector of [2 x double]. Bits [63:0] are written to bits [63:0] of the destination.
  __b | A 128-bit vector of [2 x double]. Bits [63:0] are written to bits [127:64] of the destination.

Returns
  A 128-bit vector of [2 x double] containing the interleaved values.

Definition at line 4797 of file emmintrin.h.

References __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_unpacklo_pd(), and _mm_maskz_unpacklo_pd().

## ◆ _mm_xor_pd()

static __inline__ __m128d __DEFAULT_FN_ATTRS _mm_xor_pd | ( | __m128d | __a,
|  | __m128d | __b
| ) |  |
| static

Performs a bitwise XOR of two 128-bit vectors of [2 x double].

This intrinsic corresponds to the `VPXOR / PXOR` instruction.

Parameters

  __a | A 128-bit vector of [2 x double] containing one of the source operands.
  __b | A 128-bit vector of [2 x double] containing one of the source operands.

Returns
  A 128-bit vector of [2 x double] containing the bitwise XOR of the values between both operands.

Definition at line 407 of file emmintrin.h.

References __b, and __DEFAULT_FN_ATTRS.

Referenced by _mm_mask_xor_pd(), and _mm_maskz_xor_pd().

## ◆ _mm_xor_si128()

static __inline__ __m128i __DEFAULT_FN_ATTRS _mm_xor_si128 | ( | __m128i | __a,
|  | __m128i | __b
| ) |  |
| static

Performs a bitwise exclusive OR of two 128-bit integer vectors.

This intrinsic corresponds to the `VPXOR / PXOR` instruction.

Parameters

  __a | A 128-bit integer vector containing one of the source operands.
  __b | A 128-bit integer vector containing one of the source operands.

Returns
  A 128-bit integer vector containing the bitwise exclusive OR of the values in both operands.

Definition at line 2798 of file emmintrin.h.

References __b.

## Variable Documentation

## ◆ __a

__inline__ void int __a

Initial value:
{
__builtin_ia32_movnti(__p, __a)
__a
static __inline__ void int __a
Definition: emmintrin.h:4185
__p
static __inline unsigned char unsigned int unsigned int unsigned int * __p
Definition: adxintrin.h:24

Definition at line 4185 of file emmintrin.h.

Referenced by __attribute__(), __bool2mask(), __brevll(), __divdc3(), __divsc3(), __tzmsk_u32(), _incsspd(), _mm256_broadcast_sd(), _mm256_broadcast_ss(), _mm256_castpd_ps(), _mm256_castpd_si256(), _mm256_castps_pd(), _mm256_castps_si256(), _mm256_castsi256_pd(), _mm256_castsi256_ps(), _mm256_store_si256(), _mm256_storeu_pd(), _mm256_storeu_ps(), _mm256_storeu_si256(), _mm512_int2mask(), _mm512_mask2int(), _mm_add_sd(), _mm_add_ss(), _mm_broadcast_ss(), _mm_castpd_ps(), _mm_castpd_si128(), _mm_castps_pd(), _mm_castps_si128(), _mm_castsi128_pd(), _mm_castsi128_ps(), _mm_cmplt_epi32(), _mm_cvt_si2ss(), _mm_cvt_ss2si(), _mm_cvtsi32_sd(), _mm_cvtsi32_si128(), _mm_cvtsi32_ss(), _mm_cvtss_sd(), _mm_div_sd(), _mm_div_ss(), _mm_move_sd(), _mm_move_ss(), _mm_mul_sd(), _mm_mul_ss(), _mm_storeu_pd(), _mm_storeu_ps(), _mm_sub_sd(), _mm_sub_ss(), _rdsspd(), _wrssd(), _wrussd(), cosf(), log2f(), logf(), sincosf(), sinf(), vec_abs(), vec_abss(), vec_add(), vec_addc(), vec_adde(), vec_insert(), vec_neg(), vec_promote(), vec_revb(), vec_splat_s16(), vec_splat_s32(), vec_splat_s8(), vec_splat_u16(), vec_splat_u32(), vec_splat_u8(), vec_splats(), vec_vspltisb(), vec_vspltish(), and vec_vspltisw().